cupt (2.10.4+nmu2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:50:09 +0000

cupt (2.10.4+nmu2build1) noble; urgency=medium

  * No-change rebuild against libcurl3t64-gnutls

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 06:48:10 +0000

cupt (2.10.4+nmu2) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061989

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Tue, 27 Feb 2024 23:18:16 +0000

cupt (2.10.4+nmu1) unstable; urgency=medium

  * Non-maintainer upload.
  * cmakelists: Fix boost version check (Closes: #960381)
    Based on the patch from Ubuntu

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 07 Jun 2020 22:56:21 +0200

cupt (2.10.4) unstable; urgency=low

  * console:
    - Auto-detect color support for more variants of 'xterm'-terminals.
  * lib:
    - cache:
      - Parsing sources.list records: fix parsing option values containing
        commas.
      - Parsing sources.list records: fix parsing options where there is
        no whitespace between '[' and the option key.
  * cmakelists:
    - Remove explicit setting of the policy CMP0037. Presumably, since
      CMake 3.11 the target 'test' is no longer auto-reserved.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 10 Nov 2019 10:53:34 +0100

cupt (2.10.3) unstable; urgency=low

  * debian:
    - control:
      - Use https for Homepage and Vcs-Git fields. Patch by Jelmer Vernooĳ.
    - libcupt4-2.lintian-overrides:
      - Added to override 'uses-dpkg-database-directly'.
  * test:
    - t/version.t: allow pluses and letters so the test cases still pass
      for NMUs. (Closes: #914058)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Mon, 10 Dec 2018 21:20:34 +0100

cupt (2.10.2) unstable; urgency=medium

  * lib:
    - cache:
      - Verifying repository signatures: fixed detecting 'public key not
        found' situations with recent versions of gpgv, which provide more
        than 6 fields for 'ERRSIG' status messages. Thanks to Santiago Vila
        for the report. (Closes: #902457)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 28 Jul 2018 11:56:13 +0200

cupt (2.10.1) unstable; urgency=medium

  * test:
    - t/manage/worker/packages/hooks/pre-install-pkgs/feeding-input.t:
      Increased hang-check timeout from 30s to 90s, giving more time to
      HPPA buildds. Thanks to John David Anglin for the investigation and
      Aaron M. Ucko for the report. (Closes: #882238)
  * lib:
    - system/resolver:
      - New class 'ImplicitReason'.
    - system/resolvers/native:
      - Add an appropriate reason for packages which will be implicitly
        auto-configured.
  * cmakelists:
    - Pass '-Wno-format-security' after environment-provided compile flags.
  * debian:
    - control:
      - Maintainer address is again myself instead of Alioth mailing list.
      - Bumped Standards-Version to 4.1.3, no changes needed.
      - Priority for 'cupt-dbg' is changed to 'optional', as suggested by
        lintian.
    - compat:
      - Bumped to 9.
    - source/format:
      - Introduced, with "3.0 (native)".
    - rules:
      - Pass '--parallel' after dh sequence name.
      - Use one-letter name for the build directory, since gpg-agent (used
        in the test suite) has a limit for socket path length.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 28 Apr 2018 11:21:13 +0200

cupt (2.10.0) unstable; urgency=low

  * console:
    - New positional action override option '--reinstall'.
    - Action preview prompt: removed printing "(a)" suffix for removed/purged
      automatically installed packages. Instead, introduced all-action
      package indicators: "{m}" for manually installed packages, "{a}" for
      automatically installed ones. Those 2 affect only non-color output mode.
      Only "{m}" is enabled by default.
    - Action preview prompt: fixed an internal error on showing versions for
      to-be-purged removed packages.
    - Action preview prompt: warn (by default) when removing important
      packages (the ones marked as 'Important: yes').
    - Action preview prompt: fixed showing broken installed packages as to
      be reinstalled if an user prevented their automatic
      removal/reinstallation.
    - Package action modifier suffixes '+' and '-' are now deprecated.
      They still work (for now) but produce a warning when used.
    - 'shell':
      - Don't rebuild the cache when the last action required less cache
        parts than the current one, but all needed parts were loaded before.
      - Don't rebuild the cache if simulation is on.
      - Replaced argument parsing algorithm from a shell invocation to a
        simple word parser (simple one-level shell quotes still allowed).
      - 'version' and 'help' commands now work also here.
    - 'dist-upgrade':
      - Do not apply positional arguments on the first stage (when upgrading
        package management tools).
    - 'reinstall':
      - Make non-must reinstall requests non-fatal even if there are no
        reinstallation candidates.
      - Also consider candidates having same version but different hash sums.
    - 'functional selectors':
      - New functions 'build-depends-arch' and 'build-conflicts-arch'.
      - New functions 'reverse-build-depends-arch' and
        'reverse-build-conflicts-arch.
      - New function 'important';
  * lib:
    - config:
      - New option 'cupt::console::warnings::removal-of-essential'.
      - New option 'cupt::console::warnings::removal-of-important'.
      - Don't ask dpkg for architectures if the 'apt::architecture' option
        was already set via configuration file.
      - New method 'getConfigurationPartPaths'.
      - Enable colored output on terminals by default.
      - New options in 'cupt::console::actions-preview' family:
        'package-indicators::manually-installed' and
        'package-indicators::automatically-installed'.
    - cache:
      - Verifying repository signatures: use APT keyrings directly, now that
        they're finally world-readable.
      - Verifying repository signatures: display better error message when
        a key has expired.
      - Verifying repository signatures: display 'public key not found'
        warning message also if there are no available keyrings.
      - Verifying repository signatures: treat unaccessible detached
        signatures as missing (results in better diagnostics).
      - Removed the 'copy the keyring' hack, introduced in 2.2.2.
      - Removed support of localized descriptions without a description hash
        present in the original index (even oldstable has them).
      - Parsing release files: fixed displaying 'no release file present'
        warnings if more than one release file is missing.
      - Support for 'check-valid-until=no' option in sources.list.
      - 'getSatisfyingVersions': provisional single-arch support for ':native'
        suffixes.
    - cache/binaryversion:
      - [ABI break] New member 'important'.
    - cache/sourceversion:
      - [ABI break] New member 'buildProfiles'.
      - [ABI break] 'RelationTypes': new values 'BuildDependsArch' and
        'BuildConflictsArch'.
    - system/worker:
      - 'updateReleaseAndIndexData': fixed removing partial uncompressed file
        if uncompressing of a temporary file failed.
      - 'updateReleaseAndIndexData': use new '*-Download' sections in
        diff indexes to check size and hash sums of individual diff earlier.
      - 'updateReleaseAndIndexData': dropped the obsolete way of downloading
        translation files via localication index (even oldstable has them in
        Release files).
      - 'changeSystem': do not require anymore that 'dpkg' binary package is
        installed, it's enough that dpkg binary is available.
  * doc:
    - reference:
      - Fixed Doxygen warnings about obsolete Doxyfile tags.
  * debian:
    - control:
      - Bumped the ABI suffix from 1 to 2.
      - Added build-dependency on locales-all (for locale-specific tests).
      - Added build-dependency on liblist-moreutils-perl (for tests).
      - Added build-dependency on libtest-dir-perl (for tests).
      - Added build-dependency on libexpect-simple-perl (for shell tests).
      - Added build-dependency on gpgv, gnupg, ed (for tests).
      - Removed 'breaks' of very old versions of daptup and debdelta.
      - Moved 'libcupt4-2' to sections 'libs', as lintian suggests.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 19 Nov 2017 12:46:03 +0100

cupt (2.9.10) unstable; urgency=medium

  * lib:
    - Added missing includes for GCC7. (Closes: #853362)
  * debian/control:
    - Depend on libgcrypt20-dev instead of libgcrypt11-dev (which became
      a transitional package (Closes: #864099)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 10 Sep 2017 16:35:01 +0200

cupt (2.9.9) unstable; urgency=medium

  * console:
    - 'shell': switched to libreadline7 from libreadline6. Patch by
      Sven Joachim. (Closes: #845358)
  * lib:
    - cache:
      - Verifying repository signatures: ignore unknown status lines from
        gpgv.
      - Fixed pre-parsing versioned provides when all provides for a particular
        package are versioned.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Tue, 27 Dec 2016 20:12:27 +0100

cupt (2.9.8) unstable; urgency=high

  * lib:
    - cache:
      - Verifying repository signatures: ported to gpgv v2.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Tue, 04 Oct 2016 08:40:30 +0200

cupt (2.9.7) unstable; urgency=medium

  * lib:
    - cache/relation:
      - ArchitecturedRelation: don't choke on build profiles.
  * debian:
    - cupt.dirs:
      - Don't create empty and obsolete /etc/bash_completion.d/ directory.
      - Don't create /usr/bin, it's created automatically by install targets.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 02 Oct 2016 16:59:13 +0200

cupt (2.9.6) unstable; urgency=medium

  * cmakelists:
    - Detect a GCC6 lambda capture optimisation bug (#838438), and lower the
      optimization level if found. This avoids miscompilation on armel/armhf.
      (Closes: #836588)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Fri, 23 Sep 2016 10:48:07 +0200

cupt (2.9.5) unstable; urgency=medium

  * test:
    - TestCupt:
      - Make sure APT_CONFIG environment variable is not pre-set. Fixes FTBFS
        if the building tool or environment uses APT_CONFIG for own purposes
        (like newer sbuild). Patch by Adam Conrad, thanks! (Closes: #819605).
  * debian
    - control:
      - Bumped Standards-Version to 3.9.8, no changes needed.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 19 Jun 2016 16:39:02 +0200

cupt (2.9.4) unstable; urgency=medium

  * debian/rules:
    - Fixed calling CMake's install before trying to copy translation files to
      a target package (Closes: #806010).

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 14 Feb 2016 13:36:37 +0100

cupt (2.9.3) unstable; urgency=medium

  * lib:
    - cache/package:
      - Disallow more than 1 installed version per package. This fixes data
        inconsistencies which may lead to crashes. (Closes: #794430)
    - system/state:
      - Parsing dpkg status file: error out on empty package names.
      - Parsing dpkg status file: require 'Package' tag first for every
        record.
      - Parsing dpkg status file: require 'Status' tag for every versioned
        record.
      - Parsing dpkg status file: do not stop reading when met with a newline
        instead of a first tag.
  * debian:
    - control:
      - Bumped the ABI suffix from 0 to 1 for the GCC5 C++11 ABI transition.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Tue, 25 Aug 2015 21:13:01 +0300

cupt (2.9.2) unstable; urgency=medium

  * cmakelists:
    - Temporarily added a compiler switch to use old C++11 ABI. To be removed
      when Boost libraries (which we link to) get rebuilt with new C++11 ABI.
    - Removed some obsolete/unneeded include directories.
  * debian:
    - control:
      - Added forgotten Conflicts between libcupt4-dev and libcupt3-dev.
        (Closes: #792847)
    - cupt.bash-completion:
      - Added to use dh_bash-completion instead of manual file copying.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 02 Aug 2015 18:44:22 +0300

cupt (2.9.1) unstable; urgency=medium

  * lib:
    - cmakelists:
      - Pass absolute path of 'downloadmethods' directory for local builds.
        Makes downloading work when locally built cupt binary is called from
        non-usual locations.
  * test:
    - TestCupt:
      - Made the regex parsing 'cupt policy' output stricter. This reduces
        the probability of false negatives.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Fri, 17 Jul 2015 08:32:43 +0300

cupt (2.9.0) experimental; urgency=low

  * console:
    - 'functional selectors':
      - Fixed crashing when non-first argument to and() contains package
        relationship or defining functions.
      - New function 'source-to-binary'.
    - 'search':
      - FSE mode: enabled parsing of unknown version fields.
    - 'why':
      - Prefer any number of (Pre-)Depends over 1 Recommends.
      - Prefer 2 Recommends over 1 Suggests.
      - Apply penalties for non-first relations. (Closes: #772558)
    - 'snapshot save':
      - Accept only snapshot names made of whitelist characters (lowercase
        latin letters, digits, dash, underscore).
    - Version selecting:
      - Fixed '<package>=<version>' syntax for versions with id suffixes.
  * lib:
    - Bumped API version to 4.
    - config:
      - New option 'cupt::resolver::score::version-factor::common'.
      - New option 'cupt::resolver::score::version-factor::negative'.
      - New option
        'cupt::resolver::score::version-factor::priority-downgrade'.
        (Closes: #764755)
      - New option 'cupt::resolver::max-leaf-count'.
      - Option 'cupt::resolver::max-solution-count': increased default value
        from 8192 to 32000.
      - Option 'cupt::resolver::score::quality-adjustment': changed default
        value from 40 to 0.
      - Option 'cupt::resolver::score::removal-of-autoinstalled': changed
        default value from 1200 to 1500.
      - Option 'cupt::resolver::score::upgrade': changed default value
        from 100 to 20.
      - 'setScalar': when doing APT-to-Cupt option translation, also-set
        original-case APT option instead of normalised-case APT option.
      - 'setScalar': accept any option from 'dpkg' family without filtering.
    - system/state:
      - [API break] 'getInstalledInfo': returns raw pointer.
      - [ABI break] Removed handling of longly obsolete Status fields. Patch by
        Guillem Jover. (Closes: #764468)
      - InstalledRecord::Status::strings: added strings for trigger-related
        states. Fixes crash on trying to stringify such states.
    - system/worker:
      - [API break] 'setAutomaticallyInstalledFlag': removed as obsolete.
      - Debdelta helper: use debdelta sources file path as relative to 'dir'
        option, not as absolute path.
      - 'changeSystem': preinstall hooks: pass original version strings of
        supposed versions, not id-suffixed ones.
      - 'changeSystem': preinstall hooks v3: pass '-' instead of empty string
        as architecture for purged versions.
      - 'changeSystem': dpkg commands: run '--triggers-only --pending' even if
        trigger deferring is switched off (see #766758 for discussion).
      - 'changeSystem': preserve unknown fields when writing to extended
        states file.
      - 'changeSystem': preinstall hook: if an input is supplied, don't hang
        if the hook does not accept it all.
    - system/resolvers/native:
      - Removed the version normalized score calculation skew.
        (Closes: #754480, #622939)
      - Implemented automatic quality adjustment.
      - Fixed not applying downgrade score for reinstalls. This regression
        was introduced in 2.6.0.
      - Significantly reduced not-user score part of upgrades.
      - For equal-scored version change variants (when replacing a version
        because of a broken relation), propose higher versions first.
    - versionstring:
      - [API break] 'getOriginal': return StringRange.
      - [API break] 'sameOriginal': removed as obsolete.
      - [API break] 'getOriginal': moved out of 'versionstring' namespace.
    - cache/binaryversion:
      - [API break] 'provides': are now versioned.
    - common:
      - 'checkVersionString': accept underscores (with warnings) again. This
        regression was introduced in 2.0.0~alpha1.
      - [API break] 'checkVersionString', 'compareVersionStrings': moved to
        'versionstring' header.
      - [API break] 'checkPackageName', 'consumePackageName': moved to
        'packagename' header.
      - [API break] 'checkPackageName': first parameter's type is now
        StringRange.
    - cache/relation:
      - [ABI break] Relation: new member 'architecture'.
    - cache:
      - [API break] PinnedVersion: renamed to VersionWithPriority.
      - [API break] 'getSortedPinnedVersions': renamed to
        getSortedVersionsWithPriorities.
      - Parsing extended states: don't choke on records without
        'Auto-Installed' field.
      - [ABI break] ExtendedInfo: new member 'raw'.
    - system/snapshots:
      - 'setupResolverForSnapshotOnly': don't reinstall equal versions.
        The regression was introduced in 2.6.0.
    - cache/package:
      - [API break] Constructor: removed 'binaryArchitecture' parameter.
  * doc:
    - cmakelists:
      - Added rules building man pages from PODs.
    - examples:
      - Added 'show-available' example.
    - reference:
      - Removed timestamps from documentation. Makes builds reproducible.
        Patch by Chris Lamb. (Closes: #777576)
      - Explicitly remove all Javascript files generated by Doxygen, they are
        not actually used but some versions of Doxygen keep generating them.
    - news:
      - Moved to actual 'doc' directory.
  * debian:
    - control:
      - Added 'Breaks: dpkg (<< 1.17.11~)' for versioned provides support.
      - Bumped Standards-Version to 3.9.6, no changes needed.
    - rules:
      - Enabled dh_auto_configure's build system autodetection.
      - Use -DCMAKE_BUILD_TYPE instead of -DOPTIMIZE.
    - cupt.manpages:
      - Grab man pages from preinstallation directory, not source directory.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Thu, 14 May 2015 15:11:56 +0300

cupt (2.8.4) unstable; urgency=medium

  * lib:
    - system/worker:
      - 'changeSystem': preinstall hooks: pass original version strings of
        installed versions, not id-suffixed ones. (Closes: #764754)
    - cache:
      - Version pinning: fixed matching version strings of installed versions.
        (Closes: #764238)
    - system/resolvers/native:
      - Reverted 'fixed failing to satisfy 'remove x --no-remove'-kinds of
        requests', so 'no-remove' option works again for any kind of user
        requests. This now includes explicit ones as well, so
        'remove x --no-remove' are now expected to fail if 'x' is manually
        installed package. The regression was introduced in 2.7.3.
  * cmakelists:
    - Added '-pthread' to compiling and linking flags. (Closes: #760489)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 19 Oct 2014 20:50:23 +0300

cupt (2.8.3) unstable; urgency=medium

  * lib:
    - config:
      - New option 'cupt::console::actions-preview::show-empty-versions'.
    - system/resolvers/native:
      - For equal-scored version change variants, propose higher versions
        first. The regression for some typical upgrade situations was
        introduced in 2.8.0, the regression for some typical non-upgrade
        user requests was introduced in 2.6.0, and many non-typical cases
        probably never worked before.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 04 Oct 2014 12:52:34 +0300

cupt (2.8.2) unstable; urgency=medium

  * test:
    - cmakelists:
      - Avoided trying symlinking a directory to itself for in-tree builds.
        Makes building succeed with CMake 3.0. (Closes: #758446)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Wed, 20 Aug 2014 22:12:47 +0300

cupt (2.8.1) unstable; urgency=medium

  * lib,console:
    - Used more explicit syntax for initialization of some STL structures.
      Fixes builds with g++-4.9. (Closes: #746840)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 11 May 2014 16:33:18 +0300

cupt (2.8.0) experimental; urgency=low

  * lib:
    - system/resolvers/native:
      - 'upgrade': re-implemented in terms of 'satisfyRelationExpression'.
    - cache:
      - 'getSatisfyingVersions': minimal single-arch support for ':any'
        suffixes.
    - cache/relation:
      - Constructor: reject package names starting with an allowed symbol.
    - 'consumePackageName': allow ':' character.
  * test:
    - Introduced.
  * debian:
    - libcupt3-0.shlibs: bumped to 2.8.0~.
    - control: modified short and long descriptions to stress flexibility.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Fri, 02 May 2014 18:31:24 +0300

cupt (2.7.3) unstable; urgency=low

  * lib:
    - system/resolvers/native:
      - Fixed failing to satisfy 'remove x --no-remove'-kinds of requests.
        This regression was introduced in 2.6.0.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Fri, 18 Apr 2014 17:41:29 +0300

cupt (2.7.2) unstable; urgency=low

  * lib:
    - system/resolvers/native:
      - Branch filtering heuristics: fixed skipping sticked but satisfying
        elements. This could lead to skipping some valid solutions.
        This regression was introduced in 2.7.0.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Wed, 05 Mar 2014 21:05:37 +0200

cupt (2.7.1) unstable; urgency=low

  * lib:
    - config:
      - 'setScalar': for options from foreign families, save also their
        normalized form if it's recognized/used. This regression was
        introduced in 2.7.0. (Closes: #740141)
  * doc:
    - news:
      - Filled for 2.7.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 01 Mar 2014 11:47:46 +0200

cupt (2.7.0) unstable; urgency=low

  * lib:
    - Fixed not invoking std::terminate() when a pipe process fail.
    - config:
      - New option 'cupt::directory::configuration::pre'.
      - 'setScalar': accept options from foreign families. They may be useful
        for e.g. hooks.
      - Option 'cupt::resolver::max-solution-count': increased default value
        from 512 to 8192.
    - system/resolvers/native:
      - Reduced solution memory footprint.
      - Reduced average CPU costs of postprocessing failed solutions.
      - Apply some more heuristics to reject new solution tree branches early,
        leading to from neglective/significant/major speed-ups depending on
        the problem patterns.
    - system/worker:
      - 'changeSystem': for removal actions, change automatically installed
        flag after the action, not before.
      - 'changeSystem': support VERSION 3 of preinstall hooks. Thanks to
         James McCoy for the format analysis.
      - 'changeSystem': support for sending hook input to any file descriptor
        hooks want. Thanks to James McCoy for the report. Together with an
        entry above this (Closes: 725979)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 22 Feb 2014 15:51:56 +0200

cupt (2.6.4) unstable; urgency=medium

  * lib:
    - system/worker:
      - 'renameSnapshot': don't accept invalid snapshot names.
      - Detect snapshot names having whitespace characters as invalid.
      - 'updateReleaseAndIndexData': reimplemented needed subset of <future>.
        Fixes FTBFS on armel. (Closes: #730974)
  * debian:
    - control:
      - Bumped Standards-Version to 3.9.5, no changes needed.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Tue, 24 Dec 2013 20:59:30 +0200

cupt (2.6.3) unstable; urgency=low

  * lib:
    - Standard-conformance fixes to be buildable by g++-4.8.
  * build system:
    - Removed the restriction to build only with g++-4.6.
  * debian:
    - control:
      - Removed 'g++-4.6' from Build-Depends.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Tue, 22 Oct 2013 23:05:55 +0300

cupt (2.6.2) unstable; urgency=low

  * lib:
    - system/worker:
      - 'changeSystem': fixed forgetting some multiplied dependencies if some
        not changed installed packages has a dependency on some changed
        package through more than one relation expression. This regression
        was introduced in 2.2.0~rc1.
    - system/resolvers/native:
      - Reduced a memory footprint of unprepared solutions a bit.
  * debian:
    - control:
      - Bumped Standards-Version to 3.9.4, no changes needed.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 12 Oct 2013 17:51:10 +0300

cupt (2.6.1) experimental; urgency=low

  * debian:
    - cupt.manpages:
      - Fixed installing cupt_functionalselectors.7.
    - cupt.install:
      - Fixed installing all generated HTML pages.
    - rules:
      - Don't attempt to install logrotate script in binary-arch target. Fixes
        FTBFS for binary-only builds.
  * doc:
    - cmakelists:
      - Fixed installing all generated HTML pages to /usr/share, not only
        tutorial one.
      - Fixed not installing build artefacts of 'show-upgradeable' example.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 05 Oct 2013 15:57:19 +0300

cupt (2.6.0) experimental; urgency=low

  * console:
    - Managing packages:
      - The option 'cupt::resolver::track-reasons' does not correspond to the
        console '--show-reasons' option anymore.
      - New positional action override options '--markauto', '--unmarkauto',
        '--asauto=yes', '--asauto=no', '--asauto=default'.
      - 'markauto', 'unmarkauto': are now first-class management commands.
      - Action preview prompt: now properly show reinstalled packages as
        reinstalled, not as upgraded.
      - Action preview prompt: removed the 'one expression per line'
        limitation while processing 'a' choice.
      - Action preview prompt: new choice 'rc' ("show reason chain").
      - The option 'cupt::console::actions-preview::show-summary' got a new 
        value variant "auto".
      - Warn and require extra confirmation for actions on MultiArch-enabled
        systems. (Closes: #710052)
      - New positional request type options '--select=traditional',
        '--select=flexible'.
      - New positional request importance options '--importance=must',
        '--importance=try', '--importance=wish', '--importance=<value>'.
    - 'shell':
      - Don't rebuild the cache uselessly when a package management action
        was suggested but not confirmed by user.
    - New 'functional selectors' syntax for advanced version selection. 
    - 'search':
      - New option '--fse'.
    - 'tar-metadata':
      - Include also signatures of Release files.
    - 'show', 'showsrc': syntaxes '.../<distribution>' and '...=<version>' now
      work also with '-a' option.
  * lib:
    - Removed deprecated functions 'fatal', 'warn', 'debug', 'simulate'.
    - [API break] '__': now returns 'const char*' instead of 'string'.
    - cache:
      - [API break] Pointers to Package and Version objects are now persistent
        and unique. Thus shared pointers to those objects are no more used in
        public interfaces.
      - [API break] PinnedVersion: removed explicit constructor.
      - [API break] Removed deprecated methods and structures.
      - [API break] Constructor: removed the argument
        'packageNameGlobsToReinstall' as not needed anymore.
      - [API break] 'getLocalizedDescriptions' is replaced with
        'getLocalizedDescription'.
      - [API break] 'getPolicyVersion' is renamed to 'getPreferredVersion'.
      - New possibility to use index-of-index files to speed up building
        the package cache.
      - [API break] 'getSystemState': now returns persistent constant pointer.
      - Don't include unnecessary 'boost/xpressive/xpressive_fwd.hpp'.
        (Closes: #701207)
      - [ABI break] IndexEntry: new member 'options'.
      - Support for 'trusted=yes' and 'trusted=no' options in sources.list.
      - [API break] 'getBinaryPackageNames', 'getSourcePackageNames': return
        type is now 'Range<PackageNameIterator>'.
    - cache/package:
      - Apply id version suffixes (^<suffix>) to version strings to
        differentiate versions with same version string but different hash
        sums.
      - New methods begin() and end().
      - [API break]: 'addEntry': removed.
    - cache/relation:
      - [API break] ArchitecturedRelation, ArchitecturedRelationExpression:
        constructor from string subrange is now explicit.
      - [API break] Relation, ArchitecturedRelation: removed constructors from
        strings.
      - [API break] Use 'const char*' instead of 'string::const_iterator' in
        constructors.
    - config:
      - Don't store unused APT variables anymore.
      - New option 'cupt::console::actions-preview::show-reasons'.
      - New option 'cupt::update::generate-index-of-index'.
      - New option 'cupt::console::show-progress-messages'.
      - The option 'cupt::languages::indexes' has now default value
        'environment,en' to always download English translations regardless of
        the current locale.
      - Recognize and use the option 'dir::ignore-files-silently'.
        (Closes: #697248)
      - Removed the option 'cupt::update::keep-bad-signatures', signatures are
        always kept.
    - cache/version:
      - [API break] 'operator==': removed, versions can be now compared by
        pointers' values.
      - [API break] Source, InitializationParameters: replaced shared_ptr's
        with pointers.
      - [API break] InitializationParameters: removed.
    - system/resolver:
      - [API break] SuggestedPackage: new field 'automaticallyInstalledFlag',
        removed old field 'manuallySelected'.
      - New method 'setAutomaticallyInstalledFlag'.
      - 'SuggestedPackage': new field 'reasonPackageNames'.
      - [API break] 'unsatisfyRelationExpression': removed, merged into
        'satisfyRelationExpression' with new boolean parameter.
      - [ABI break] 'satisfyRelationExpression': added new parameters 'invert'
        'annotation', 'importance', 'asAutomatic'.
      - [API break] 'installVersion': now set of possible versions can be
        passed.
      - [API break] 'removePackage': removed, replaced by new, more flexible
        method 'removeVersions'.
    - system/worker:
      - [API break] 'setPackagePurgeFlag': now is persistent, and should be
        called before 'setDesiredState'.
      - [ABI break] 'Action::Type' new enum value 'Reinstall'.
      - 'updateReleaseAndIndexData': use threads instead of forking.
      - 'updateReleaseAndIndexData': initial support for InRelease files.
        (Closes: #623113)
    - cache/binarypackage:
      - 'getInstalledVersion': significant speed-up.
      - New methods begin() and end().
    - cache/binaryversion:
      - [API break] Fields 'shortDescription' and 'longDescription' are
        replaced with a new field 'description'.
      - [API break] 'parseFromFile': removed.
      - [ABI break] New field 'descriptionHash'.
    - cache/sourceversion:
      - [API break] 'parseFromFile': removed.
    - cache/sourcepackage:
      - New methods begin() and end().
      - Stopped filtering out packages with unapplicable binary architectures.
    - file:
      - [API break] Not a public API anymore.
    - system/state:
      - New method 'getArchitecture'.
    - download/manager:
      - Removed 'alive pings'.
      - Notify the download progress of download sizes earlier. This improves
        the total percent accuracy where a grand total size is not known
        beforehand (for example, metadata updates).
      - [ABI break] 'DownloadEntity': new member 'optional'.
    - download/method{,factory}:
      - [API break]: don't require shared_ptr< Config > anymore.
    - download/progress:
      - Added support for the dynamic changes of expected download sizes.
      - [API break]' 'DownloadRecord': the field 'beingPostprocessed' is
        replaced with a new field 'phase'.
      - [API break] 'setTotalEstimatedSize': removed as superseded by early
        notificiations by download manager.
      - New methods 'markAsOptional' and 'isOptional'.
    - download/progresses/console:
      - Changed the format of outputting download number prefixes.
    - hashsums:
      - Fixed non-thread-safe initialization of libgcrypt.
    - system/resolvers/native:
      - Adjusted version normalized score calculation that a version from
        non-default release has a positive score, and thus removing it gets,
        by default, a penalty, not a bonus.
    - range:
      - New module.
  * downloadmethods:
    - debdelta:
      - Pass delta size (when/if known) to download progress.
        (Closes: #690914)
  * doc:
    - tutorial:
      - In the man page version, all command examples are now marked bold.
    - man/cupt.1:
      - Fixed the typo: suffix -> prefix in the 'pkgnames' command.
        (Closes: #689518)
  * scripts:
    - bash_completion:
      - Suppress standard error messages in invocations of 'cupt'.
  * debian:
    - control:
      - Bumped the library API version.
      - New binary package 'libcupt-common'.
  * build system:
    - Specify OUTPUT_NAME property for targets. As a side effect this
      obsoletes the custom cupt.bin install statement which prevented 'make
      install' from working for out-of-tree builds. (Closes: #683872)
    - doc:
      - Fixed 'make install' for out-of-tree builds.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Mon, 30 Sep 2013 21:45:27 +0300

cupt (2.5.11) unstable; urgency=low

  * doc:
    - man/cupt.conf.5:
      - Fixed '--no-auto-remove' reference syntax. Fixes building with recent
        pod2man. (Closes: #724133)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Fri, 27 Sep 2013 18:31:59 +0300

cupt (2.5.10) unstable; urgency=low

  * lib:
    - download/manager:
      - Avoid memory allocations in a signal handler when sending internal
        pings. This could hang the download manager. Many thanks to
        James McCoy for the final analysis. (Closes: #710239)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Tue, 25 Jun 2013 20:57:51 +0300

cupt (2.5.9) unstable; urgency=low

  * lib:
    - download/uri:
      - Constructor: accept single- or triple-slashes after the ':' character,
        which is the usual situation for 'file' or 'copy' schemes.
        Thanks to Alexey Ivanov for the report. (Closes: #683873)
    - system/nativeresolver:
      - Fixed 'internal error: conflicting elements' in the corner case when
        one version of package A depends on a certain version which in turn
        depends on a different version of package A, plus additional
        circumstances apply.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Wed, 15 Aug 2012 19:45:35 +0300

cupt (2.5.8) unstable; urgency=low

  * lib:
    - cache/binaryversion:
      - 'parseFromFile': the field 'Description-md5' should be parsed together
        with info-only fields even if Version::parseOthers is off.
        (Closes: #681340)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 14 Jul 2012 13:55:39 +0300

cupt (2.5.7) unstable; urgency=low

  * lib:
    - cache:
      - Parsing sources list: parse afterline comments properly. Thanks to
        Alexey Ivanov for the report. (Closes: #678345)
  * doc:
    - tutorial:
      - 'Disadvantages': said specificly that multiarch is not supported.
  * po:
    - Added German translation by Chris Leick. (Closes: #677758)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Thu, 28 Jun 2012 14:03:52 +0300

cupt (2.5.6) unstable; urgency=low

  * lib:
    - system/worker:
      - Fatal errors should be logged regardless of the logging level.
      - Work around FreeBSD kernels on which mkdir(2) sometimes return EISDIR.
        Thanks to goneri@rulezlan.org for the report. (Closes: #675760)
  * po:
    - Added French translation by Julien Patriarca. (Closes: #675689)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Fri, 08 Jun 2012 13:01:55 +0300

cupt (2.5.5) unstable; urgency=low

  * lib:
    - download/methodfactory:
      - Loading download methods: fixed a crash when a download method library
        filename without extension contains less than 3 characters. Also,
        don't output a debug messages in this case when the debugging is not
        turned on.
    - cache/sourceversion:
      - 'parseFromFile': accept the value 'source' as if it was 'extra' for
        'Priority' field (a workaround for #626394).
    - Parsing Release files: fixed mixing unknown hash sum types and known
      hash sum values which leads to a wrong 'hash sums mismatch' error.
      Thanks to Karol Kozłowski for the report.
  * debian:
    - control:
      - Long description: made more specific about 'option name checker'.
  * doc:
    - tutorial:
      - 'Advantages': said more specificly that 'option name checker' is for
        the 'cupt::' option family.
      - 'Disadvantages': explicitly said that Cupt does not currently support
        repositories without a Release file.
    - man/cupt.1:
      - Added the user support mailing list.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 27 May 2012 12:24:20 +0300

cupt (2.5.4) unstable; urgency=low

  * lib:
    - system/resolvers/native:
      - Fixed an internal error when a not installed package was considered
        but then autoremoved (under certain conditions). This regression was
        introduced in 2.5.0. Thanks to Karol Kozłowski for the report.
        (Closes: #672693)
    - download/methodfactory:
      - [Jonathan Nieder] 'getDownloadMethodForUri': include the protocol to
        the 'no download handlers' error message.
  * po:
    - Added Slovak translation by Ivan Masár. (Closes: #671793)
  * debian:
    - control:
      - [Jonathan Nieder] Suggest installing a download method in the 'cupt'
        package description. Thanks to Manuel A. Fernandez Montecelo for the
        report. (Closes: #672804)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Tue, 15 May 2012 20:32:36 +0300

cupt (2.5.3) unstable; urgency=low

  * console:
    - Enable message translations as early as possible. Enables translations
      for for '--help' command. Thanks to Karol Kozłowski for the report.
    - 'show', 'showsrc':
      - Use localized priority strings.
      - Use localized relation strings.
    - 'show':
      - Use localized installed state strings.
    - 'showrc':
      - Use localized source package part strings.
    - 'depends', 'rdepends', 'why':
      - Use localized binary relation strings.
  * lib:
    - system/resolvers/native:
      - Stopped using unique_ptr<void>, fixing a small memory leak. This
        regression was introduced in 2.0.0~alpha3.
      - Fixed another small memory leak, introduced in 2.5.0.
    - config:
      - Added a support for the '/* ... */'-comments.
  * po:
    - Added Polish translation by Karol Kozłowski. (Closes: #671092)
    - Added partial Danish translation by Joe Dalton. (Closes: #671119)
    - getpot:
      - Set 'report msgid bugs to' field to the development mailing list.
  * doc:
    - reference:
      - Disable jquery-based search.
  * debian:
    - control:
      - Added build-dependency on gettext.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Thu, 03 May 2012 22:54:26 +0300

cupt (2.5.2) unstable; urgency=low

  * lib:
    - cache:
      - Constructor: source index alias: fixed placing the square brackets
        around the suffix "source".
      - Constructor: parsing index localization files: support the old index
        localization files scheme again. This regression was introduced in
        2.5.0.
      - Constructor: parsing index localization files: don't skip silently
        the rest of the file if a distance between records is more than one
        empty line. This regression was introduced in 2.0.0~alpha3.
  * Grammar and style fixes for translatable messages by Justin B Rye.
  * debian/control:
    - Changed the maintainer address to 'cupt-devel@lists.alioth.debian.org'.
    - Added myself to uploaders.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 07 Apr 2012 12:24:38 +0300

cupt (2.5.1) unstable; urgency=low

  * lib:
    - cache:
      - Fixed the error, when the actions which need package descriptions
        stopped to work when any needed Release file cannot be opened or
        parsed. This regression was introduced in 2.5.0.
        (Closes: #666762)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 01 Apr 2012 18:34:14 +0300

cupt (2.5.0) unstable; urgency=low

  * console:
    - 'rdepends':
      - Small speed-up by using more aggressive caching.
    - Managing packages:
      - Action preview prompt: moved auto-removed packages to a new
        'no longer needed' section.
      - Action summary: don't print zero-sized parts.
  * lib:
    - system/worker:
      - Updating release and index data: use the information about Translation
        files from Release files if provided.
      - Support Translation diffs.
    - download/manager:
      - Avoid using new[]() in processing socket messages.
      - Use std::queue instead of system pipe for the worker's internal
        message queue.
    - config:
      - New option 'cupt::resolver::no-autoremove-if-rdepends-exist'.
        (Closes: #658981)
      - New option 'cupt::resolver::score::removal-of-autoinstalled'.
      - Lowed a bit the default value of the option
        'cupt::resolver::score::removal'.
      - Parsing configuration files: fixed ignoring the incorrect syntax
        before the end of file in some cases.
      - Parsing configuration files: in the case of a syntax error print the
        line number and character number instead of the part of context string.
      - 'setScalar', 'setList': don't print warnings anymore for unknown
        non-Cupt-specific options (those which names don't start with 'cupt::')
    - download/progresses/console:
      - Status line: leave the cursor at the end of line so anynchronous
        warning and error messages are printed on the next line, not over the
        status line.
    - cache/package:
      - When throwing away a duplicate version with different hash sums, show
        also left origins in the warning message.
    - system/resolvers/native:
      - Score calculation: for removals of packages which are not manually
        installed, apply also the 'removal-of-autoinstalled' score.
        (Closes: #662027)
      - Fixed the memory leak. It was introduced in 2.0.0~alpha4.
      - Reverted skipping solutions if an auto-removed element is (partially)
        sticked. It could introduce very long delays in the solution
        calculations in some rare cases.
    - cache:
      - Constructor: don't parse release files more than once.
      - Constructor: parsing release, index and localization files: use
        an alias instead of the full path in the error and warning messages.
      - Constructor: parsing index localization files: print an error when
        the file exists but can't be opened.
      - Parsing release files: don't warn anymore if the 'archive' or 'vendor'
        fields are missing.
    - Don't include a not exported header from cupt/common.hpp, making a
      development binary package usable again. Fixes a regression since
      2.3.0~rc1.
    - Remove accidentally included 'using std::string' from a global namespace.
      Fixes a regression since 2.3.0~rc1.
  * downloadmethods:
    - wget:
      - Use threads instead of explicit fork()s.
      - User-Agent now has a libcupt-specific suffix.
    - curl:
      - User-Agent now has a libcupt-specific suffix. (Closes: #663381)
  * Improvements in the error and warning messages.
  * debian:
    - libcupt2-0.shlibs: added with an initial value of 2.3.0~rc1.
    - shlibs.local: added as an alias to above.
    - control:
      - Bumped Standards-Version to 3.9.3, no changes needed.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 31 Mar 2012 16:37:13 +0300

cupt (2.4.1) unstable; urgency=medium

  * console:
    - Managing packages:
      - Fixed possible spontaneous 'Enter a package expression' messages while
        resolving problems when no solutions were found and no exception was
        thrown. This regression was introduced in 2.0.0~rc1.
  * lib:
    - system/resolvers/native:
      - Fixed throwing an exception when some solutions were found but all of
        them were autorejected. This can happen only if some solutions were
        dropped due to a solution count requirement (the option
        'cupt::resolver::max-solution-count'). This regression was introduced
        in 2.4.0 and also made the 'Enter a package expression' regression
        above able to show itself.
    - cache:
      - Constructor: don't error out if an extended states file is not
        present, print a warning instead. (Closes: #663382)
      - Reading APT pin preferences: fixed incorrect line numbers in error
        messages.
    - system/worker:
      - Create the main archives directory if it doesn't exist.
      - 'setAutomaticallyInstalledFlag': create the directory chain (if needed)
        for creating the extended states file.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Thu, 15 Mar 2012 20:22:15 +0200

cupt (2.4.0) unstable; urgency=low

  * Switched the compiler from g++ 4.5 to g++ 4.6.
    - The compiler now can generate trivial move-constructors itself.
      Patch by Jonathan Nieder. (Closes: #647142)
  * console:
    - 'policy', 'policysrc':
      - New option '--show-dates'.
    - 'show':
      - Don't output 'Description-md5' field.
    - New subcommand 'iii'.
    - Actions preview:
      - Don't show size changes for 'not preferred' group.
      - Don't show reasons for 'not preferred' group.
    - Managing packages:
      - New option '--show-archives'.
      - New option '--show-codenames'.
      - New option '--show-components'.
      - New option '--show-vendors'.
    - 'search':
      - Switch off processing index translations in 'names-only' mode.
  * lib:
    - config:
      - The option 'cupt::resolver::score::position-penalty' now defaults to
        -2 (was -20).
      - Adjusted default values of options
        'cupt::resolver::score::{new,removal,quality-adjustment}' for changes
        in the score calculation (see below).
      - New (and default from now on) option value 'auto' for the option
        'cupt::worker::defer-triggers'.
      - New option 'cupt::console::actions-preview::show-versions'.
      - New option 'cupt::console::actions-preview::show-size-changes'.
      - New option 'cupt::console::actions-preview::show-archives'.
      - New option 'cupt::console::actions-preview::show-codenames'.
      - New option 'cupt::console::actions-preview::show-components'.
      - New option 'cupt::console::actions-preview::show-vendors'.
    - system/resolvers/native:
      - Use normalized version priority in score calculations.
      - If a solution to a problem is an "unsatisfied" element, partially
        stick all competing solution elements, not only preceding ones.
      - Skip a solution if some element to auto-remove cannot be removed
        due to being (partially) sticked. (Closes: #641473)
      - Removing automatically installed packages: if several automatically
        installed packages satisfy the relation, leave only first of them.
    - system/worker:
      - If the option 'cupt::worker::defer-triggers' is set to 'auto', check
        for recent enough version of dpkg (1.16.1).
    - cache:
      - 'getLocalizedDescriptions': use new 'Description-md5' binary version
        field if available. (Closes: #657872)
      - Don't preprocess index localization files when Version::parseInfoOnly
        variable is false.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Mon, 30 Jan 2012 21:37:15 +0200

cupt (2.3.3) unstable; urgency=low

  * console:
    - 'tar-metadata': include also Cupt-specific configuration files.
  * lib:
    - system/worker:
      - Generating dpkg package sequence: fixed non-propagating low-level
        subactions to higher-level subgroups in some cases. This regression
        was introduced in 2.2.0~rc1. Thanks to Jonathan Nieder for the report.
        (Closes: #656566)
  * doc:
    - tutorial:
      - Explicitly documented what infrastructure Cupt uses.
  * debian:
    - libcupt2-0.postrm:
      - Remove '/var/lib/cupt' directory completely on 'purge'.
        (Closes: #656457)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 21 Jan 2012 12:43:56 +0200

cupt (2.3.2) unstable; urgency=low

  * console:
    - 'show', 'showsrc': package name wildcards now work with '--all-versions'.
      (Closes: #651889)
  * lib:
    - cache:
      - Pin preferences: fixed 'origin' pin type support. (Closes: #651890)
      - Pin preferences: print a more user-friently error message when pin
        priority is not a valid integer. (Closes: #651894)
      - Parsing Release files: use 'Version' field when it's present.
        (Closes: #652379)
  * doc:
    - man/cupt.1:
      - Documented the option '--show-not-preferred'. (Closes: #651888)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Mon, 19 Dec 2011 20:16:26 +0200

cupt (2.3.1) unstable; urgency=low

  * console:
    - Managing packages:
      - 'reinstall': always use and enforce the installed version.
        (Closes: #650214)
  * lib:
    - cache:
      - Fixed printing an error reason when could not open a release file
        (a regression since 2.3.0~rc1).
    - system/worker:
      - 'getArchivesInfo': avoid using glob(3) which follows symlinks.
        (Closes: #638327)
      - Updating release and index data: cleaning obsolete files: avoid using
        glob(3) which follows symlinks. (Closes: #650128)
  * doc:
    - man/cupt.1:
      - Removed a documentation for option '--no-install-unpacked' which was
        removed in 0.6.5. (Closes: #650126)
    - tutorial:
      - Fixed typos and misspellings found by A. Costa. (Closes: #650372)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 04 Dec 2011 11:05:22 +0200

cupt (2.3.0) unstable; urgency=low

  * Upload to unstable.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 27 Nov 2011 13:14:13 +0200

cupt (2.3.0~rc1) experimental; urgency=low

  * console:
    - Common options:
      - New options '--include-archives', '--exclude-archives',
        '--include-codenames', --exclude-codenames'.
    - 'policy':
      - 'Candidate' field name is ambiguous, changed it to 'Preferred'.
    - 'source':
      - Downloading source package parts: include only those codename/component
        pairs to long descriptions which belong to a selected base
        download URI.
      - Don't try to re-download already existing (i.e. hash sums match) files.
    - Managing packages:
      - Don't print misleading 'Performing requested actions' when there is
        nothing to do.
      - New option '--show-not-preferred'.
      - Don't uppercase action names anymore.
      - Show also action summary.
      - New options '--summary-only', '--no-summary'.
    - 'search':
      - Output short description(s) even if all search expressions was found in
        the package name.
      - Sort packages before the processing. That reduces a program's system
        time by making file reads more linear. As a consequence, an output is
        now sorted too.
      - Now searches in the localized description if present.
  * lib:
    - system/resolvers/native:
      - Removing automatically installed packages: stopped considering
        those inter-package relations which are satisfied by some
        non-removable package.
      - Implemented partially sticked packages. This should get rid of
        duplicate solutions. (Closes: #641473)
    - download/progresses/console:
      - Printing 'download failed' messages: use a download number instead of
        the download description.
      - Printing 'download failed' messages: reformatted to have the error
        string earlier in the string and match the 'Get:<number>' style.
    - config:
      - New options 'cupt::cache::limit-releases::by-archive',
        'cupt::cache::limit-releases::by-archive::type'.
      - New options 'cupt::cache::limit-releases::by-codename',
        'cupt::cache::limit-releases::by-codename::type'.
      - New option 'cupt::console::actions-preview::show-not-preferred'.
      - New options 'cupt::console::actions-preview::show-summary',
        'cupt::console::actions-preview::show-details'.
      - New option 'cupt::cache::pin::addendums::but-automatic-upgrades'.
      - The APT option 'apt::acquire::translations' is no more used.
      - New option 'cupt::languages::indexes'.
      - New option 'cupt::console::use-colors'.
      - Recognize (but don't use) the APT option 'acquire::languages'.
    - system/worker:
      - Logging: log errors too.
      - Downloading package archives: include only those codename/component
        pairs to long descriptions which belong to a selected base
        download URI.
      - Updating release and index data: use i18n/Index for downloading package
        description localizations (Closes: #547948).
      - Updating release and index data: download all variants of requested
        description localizations, not only the first successful one.
      - 'getArchivesInfo': fixed an undefined behavior while obtaining the
        result of readlink(2). (Closes: #638327)
    - cache:
      - Honor 'cupt::cache::limit-releases::*' options.
      - Process all requested translations, not only the first successful one.
    - cache/releaseinfo:
      - New field 'butAutomaticUpgrades'.
    - hashsums:
      - Reduce CPU overhead of the calculating hashes of short strings.
    - 'fatal', 'warn', 'debug', 'simulate': are deprecated now.
  * doc:
    - man:
      - [Jonathan Nieder] Split off a cupt.conf(5) page from cupt(1).
        Thanks to A. Costa for the idea (Closes: #648012).
    - What was referred as 'candidate version' is really
      the 'preferred version'.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Mon, 21 Nov 2011 21:18:47 +0200

cupt (2.2.2) unstable; urgency=low

  * debian:
    - libcupt2-0.postinst:
      - Don't copy APT GnuPG keyring here anymore. Since 2.1.x Cupt has its
        own directory for repository caches so no work is possible until
        the repository lists are generated first time, and at that time
        the keyring will be copied anyway.
  * lib:
    - cache:
      - Use 'apt-key exportall' in the 'copy the keyring' hack. Thanks to
        Jonathan Nieder for the report and the patch idea. (Closes: #646993)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Mon, 31 Oct 2011 21:40:46 +0200

cupt (2.2.1) unstable; urgency=low

  * console:
    - Managing packages:
      - Fixed the work of action override options inside the interactive
        prompt for new package expressions.
      - 'markauto', 'unmarkauto': reject not installed packages. Thanks to
        Karol Kozłowski for the report.
  * lib:
    - system/resolvers/native:
      - Made sure that if the package is auto-removed there are no other
        resolver reasons present. Thanks to Karol Kozłowski for the report.
        (Closes: #643798)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Thu, 06 Oct 2011 20:42:16 +0300

cupt (2.2.0) unstable; urgency=low

  * Upload to unstable.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 17 Sep 2011 16:17:38 +0300

cupt (2.2.0~rc2) experimental; urgency=low

  * lib:
    - system/worker:
      - Downloading of index data should continue regardless of the download
        result of Release signature. Thanks to Karol Kozłowski for the report.
      - Don't run pre-install-packages hooks if there is no packages to
        unpack.
      - [Jonathan Nieder] Switch back to system() for running commands without
        an input, such as dpkg, providing them a standard input from
        a terminal. Fixes the regression since 2.2.0~rc1. (Closes: #640849)
    - hashsums:
      - Don't check gcrypt version despite what is advised in its manual.
        Linker does its work fine.
  * debian:
    - control:
      'libcupt2-0': set Breaks against download methods earlier than 2.0.0~rc1
      because of the redirect download option change.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 11 Sep 2011 13:52:25 +0300

cupt (2.2.0~rc1) experimental; urgency=low

  * console:
    - Managing packages:
      - New positional action override options '--install', '--remove',
        '--satisfy', '--unsatisfy'.
      - The option '--purge' is converted to positional action override one.
      - The action 'purge' does not set global purge flag anymore but only
        purges packages specified as arguments.
    - 'clean', 'autoclean': remove also partially downloaded archive files.
      Thanks to Karol Kozłowski for the suggestion. (Closes: #633485)
    - 'version': support '-v' as a alias again. (Closes: #640148)
  * lib:
    - system/worker:
      - New method 'setPackagePurgeFlag'.
      - The global purge option now unconditionally purges all removed
        packages again.
      - New method 'deletePartialArchives'.
      - Really allow removing Essential packages (when requested and passed
        all front-end checks).
      - Unpack/configure actions of some important packages were not optimally
        merged before when there are reverse-[Pre-]Depends.
      - Prefer temporary breaking reverse-Depends than anything else.
        (Closes: #637233)
      - Don't modify first-level priorities of non-first subactions of
        the same package, except of incrementing prioties for
        unpack-after-removal actions.
      - Greatly simplified the algorithm of setting priority links. Increases
        processing speed a lot.
      - Set dependency dpkg force options according to broken relations, not
        "nothing or all".
      - Make dpkg sequence output fixed between the different runs for the
        same input.
      - Made the virtual vertices' CPU and RAM footprint smaller.
      - Removed ad-hoc pre-dependency check warnings as useless and obsolete.
      - Merge remove/unpack subactions even more aggressively.
      - Submit the input for a running commands using pipes instead of 'echo'
        shell command. (Closes: #637494)
      - Implemented logging.
      - An initial support of repository index deltas.
    - config:
      - New option 'cupt::cache::release-file-expiration::ignore'.
      - Use APT option 'acquire::http::allowredirect' instead of Cupt-specific
        'acquire::http::allow-redirects'.
      - New option 'cupt::update::check-release-files'. Thanks to
        Karol Kozłowski for the suggestion. (Closes: #633492)
      - Support Cupt-specific configuration files (/etc/cupt by default).
        New options 'cupt::directory::configuration',
        'cupt::directory::configuration::main',
        'cupt::directory::configuration::main-parts'.
      - New option 'cupt::worker::use-locks'.
      - Recognize APT variables 'dir::log', 'dir::log::terminal',
        'dir::log::history'.
      - New options 'cupt::directory::log', 'cupt::worker::log'.
      - New options 'cupt::worker::log::levels::{metadata,packages,snapshots}'.
    - cache:
      - 'verifySignature': is deprecated now.
    - system/resolvers/native:
      - Implemented 'reinstall or remove' for packages that require the
        reinstallation.
      - Installed packages with the status 'half-installed' also require
        the reinstallation, mark them as such. (Closes: #637490)
    - file:
      - Constructor now accepts "pw" as a special mode for shell pipes opened
        for writing.
    - system/state:
      - Add package entry to the cache even if the installed version requires
        the reinstallation. (Closes: #639605)
      - InstalledRecord: new method 'isBroken'.
    - download/manager:
      - Fixed handling of EINTR while polling waiter sockets.
  * doc:
    - cupt(1) manual:
      - Documented 'purge' subcommand.
      - Fixed a typo in the description of '--download-only' option.
        (Closes: #639160)
  * scripts:
    - logrotate:
      - Created.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Mon, 05 Sep 2011 19:05:03 +0300

cupt (2.1.3) unstable; urgency=low

  * lib:
    - system/worker:
      - 'getArchivesInfo': fixed returning absolute path for files downloaded
        by APT. Thanks to Karol Kozłowski and James Vega for noticing.
  * debian:
    - libcupt2-0.install:
      - Really install 'file' download method.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 24 Jul 2011 13:31:34 +0300

cupt (2.1.2) unstable; urgency=low

  * console:
    - Fixed a crash (under certain conditions) when package wildcards are
      used within the 'shell' subcommand. Thanks to Karol Kozłowski for the
      report.
  * lib:
    - common:
      - Fixed a double use of va_list. Thanks to Julian Andres Klode for the
        report and the patch. (Closes: #630824)
    - system/worker:
      - [Jonathan Nieder] Do not assume the return value from memcmp is -1, 0,
        or 1. Fixes a bug in which cupt would sometimes leave out the <, =,
        or > symbol in VERSION 2 input for preinstall hooks. (Closes: #633138)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 10 Jul 2011 13:10:46 +0300

cupt (2.1.1) unstable; urgency=low

  * lib:
    - download/manager:
      - Use poll(2) instead of SO_RCVTIMEO socket property to check for worker
        socket timeouts. Thanks to Jonathan Nieder for the report.
        (Closes: #628992, #630600)
      - Avoided creating new process groups. Fixes delivering stop/resume
        signals to the downloader's worker process. Thanks to Jonathan Nieder
        for the report. (Closes: #629210)
    - system/worker:
      - If the global purging flag was turned on, worker still purged,
        not only removed the packages, removed by resolver, despite the right
        action preview. Fixed this feature, which was introduced in
        2.0.0~beta1.
  * Pass '-ggdb' to the compiler. Makes builds with 'nostrip' in
    DEB_BUILD_OPTIONS debuggable.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Wed, 15 Jun 2011 19:43:58 +0300

cupt (2.1.0) unstable; urgency=low

  * console:
    - New 'showauto' subcommand.
  * lib:
    - cache/relation:
      - Relation: new copy constructor from Relation&&.
      - RelationLine: new method 'operator=(RelationLine&&)'.
      - RelationExpression: new copy constructor from RelationExpression&&.
      - ArchitecturedRelation: new copy constructor from
        ArchitecturedRelation&&.
      - ArchitecturedRelationExpression: new copy constructor from
        ArchitecturedRelationExpression&&.
      - ArchitecturedRelationLine: new method
        'operator=(ArchitecturedRelationLine&&)'.
    - system/worker:
      - A small speed-up of generating dpkg action sequences for large queries.
      - RAM usage optimizations.
      - [Julian Andres Klode] Introduced a support for xz-compressed index
        files. (Closes: #623129)
      - Create lists directory if it does not exist.
    - config:
      - Be more clear in configuration file error messages that they talk
        about syntax errors.
      - New configuration variable 'cupt::directory::state::lists'.
      - Changed the default value of the variable
        'cupt::update::keep-bad-signatures' to 'yes'.
      - New configuration variable
        'cupt::resolver::score::removal-of-essential'.
    - cache:
      - Support regular expressions in pin preferences. Thanks to
        Julian Andres Klode for the suggestion. (Closes: #587478)
      - When skipping an index or translation file processing due to an error,
        use a human-readable alias in the warning message.
      - Mark structures and methods, which are related to local and remote
        locations of internal cache files, as deprecated.
    - system/resolvers/native:
      - RAM usage optimizations.
      - Do not depend on cache memoizing. Fixes a regression introduced in
        2.0.0~beta1.
      - Apply a penalty for removal of an essential package regardless of the
        score sign.
    - cache/{source,binary}version:
      - Don't error out, only print a warning for unrecognized values of the
        'Priority' field. Fixes a regression introduced in 2.0.0~alpha1.
  * debian:
    - control:
      - Relax Boost build requirements to match 1.42 and higher, not only
        1.42.
      - Vcs-Browser: the main branch is now 'master' again.
      - Bumped debhelper build-dependency to (>= 7.4.10) to use --parallel.
      - Bumped Standards-Version to 3.9.2, no changes needed.
    - rules:
      - Support 'noopt' in DEB_BUILD_OPTIONS. (Closes: #628405)
      - Support 'parallel=N' in DEB_BUILD_OPTIONS.
  * Support out-of-tree builds. (Closes: #623115)
  * Switched to Cupt-specific directory 'cupt::directory::state::lists' for
    index lists.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 29 May 2011 12:46:37 +0300

cupt (2.0.2) unstable; urgency=low

  * lib:
    - download/methodfactory:
      - Don't try to unload a module twice if it was loaded successfully but
        no needed symbols were found.
    - download/uri:
      - Correctly handle URIs with tree slashes, such as 'file:///...'.
  * downloadmethods:
    - file:
      - Implemented. Fixes a regression since 2.0.0~alpha1. (Closes: #624216)
  * doc:
    - reference:
      - 'File::getBlock': documented an output value of the 'size' parameter.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 30 Apr 2011 14:31:22 +0300

cupt (2.0.1) unstable; urgency=low

  * lib:
    - download/manager:
      - Give a warning instead of an error on the systems where the socket
        option SO_RCVTIMEO is not supported. Thanks to Jonathan Nieder for
        the analysis.
    - [Jonathan Nieder] Don't check for WIFCONTINUED. (Closes: #623159)
  * debian:
    - control:
      - Fixed typo 'arternative' in some short descriptions.
  * doc:
    - reference:
      - Hide 'CUPT_API' macro in declarations.
      - Hide 'CUPT_*' macro definitions.
    - tutorial:
      - Documented repository cache layout incompatibility with recent
        versions of APT.
      - Documented a tuning of resolver's maximum solution count.
      - Documented package archives cleaning.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Mon, 25 Apr 2011 12:15:20 +0300

cupt (2.0.0) unstable; urgency=low

  * Upload to unstable.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 16 Apr 2011 12:48:44 +0300

cupt (2.0.0~rc2) experimental; urgency=medium

  * lib:
    - Make sure that std::min() receives arguments of the same type.
      Fixes FTBFS on some architectures. (Closes: #622061)
    - download/uri:
      - 'getHost': fixed to not include a port to the answer. Thanks to
        Julian Andres Klode for the report. The regression was introduced
        in 2.0.0~alpha1. (Closes: #621853)
      - 'getHost': fixed to not include credentials to the answer.
        The regression was introduced in 2.0.0~alpha1.
    - system/resolvers/native:
      - Fixed applying penalty on removing essential packages even if proposed
        version is not essential anymore.
      - Made the penalty on removing essential packages not pin-dependent and
        much bigger.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Tue, 12 Apr 2011 19:46:59 +0300

cupt (2.0.0~rc1) experimental; urgency=low

  * console:
    - Action preview prompt:
      - Allow specifying several package expressions under 'a' choice before
        re-running a resolver.
    - 'dist-upgrade':
      - [Jonathan Nieder] Pre-upgrade 'cupt' package first, not
        'cupt-experimental'. Fixes a regression introduced in 2.0.0~beta2.
    - 'help':
      - Removed the temporary message that 'snapshot' subcommand is not
        implemented, it's implemented since 2.0.0~alpha3.
    - 'config-dump':
      - Print empty value list first for all list options.
    - Added '--as-needed' to link flags.
  * lib:
    - Always set 'close-on-exec' flag for internal pipes.
    - system/resolvers/native:
      - Fixed an algorithmic bug in calculating error trees when no solutions
        are found, which might lead to incorrect trees sometimes.
      - Output a warning about no effect when 'apt::install-<X>' option is set
        but 'cupt::resolver::keep-<X>' option is unset.
      - Fixed an endless loop when calculating error trees in some rare cases.
      - Consider all binary builds (not only selected one) of some source
        package version to be already synchronized with any binary build of
        the related package. Fixes a bug which was present since an initial
        implementation of synchronizing source versions.
      - Changed scoring system once again, to overcome some design bugs in
        previous one.
      - Try to make backtracking more effective by processing "derived"
        problems closer to their "parents".
    - file:
       - Always set 'close-on-exec' flag for opened file descriptors.
    - config:
      - Recognize 'acquire::cdrom::*' variables.
      - The option is 'cupt::cache::obey-hold' is renamed to
        'cupt::cache::pin::addendums::hold'.
      - New option 'cupt::cache::pin::addendums::not-automatic'.
      - The option group 'cupt::resolver::tune-score::*' is renamed to
        'cupt::resolver::score::*'.
      - Deleted the option 'cupt::resolver::quality-bar', it's superseded by
        the option 'cupt::resolver::score::quality-adjustment'.
      - New option 'cupt::cache::pin::addendums::downgrade'.
      - The option 'cupt::resolver::synchronize-source-versions' is renamed
        to 'cupt::resolver::synchronize-by-source-versions'.
    - download/manager:
      - Pass the right pointer to setitimer() when disabling SIGALRM. Thanks
        to Jonathan Nieder for the report. (Closes: #619727)
      - Fixed undefined behavior in handling duplicated downloads.
        Fixes a regression introduced in 2.0.0~alpha1.
    - cache:
      - Apply an additional pin priority penalty for not automatic releases.
    - Set of close-on-exec flag changes above Closes: #619650. Thanks to
      Jonathan Nieder for the report and an initial patch set.
    - Non-API symbols are not exported anymore.
  * doc:
    - reference:
      - Removed protected members of cupt::cache::Package and its subclasses
        from the documentation, they exist for internal usage only.
    - tutorial:
      - Created.
  * scripts:
    - bash_completion:
      - Complete 'cupt', not 'cupt-experimental'. Fixes a regression
        introduced in 2.0.0~beta2.
      - Pre-filter package names using 'cupt pkgnames <start>', it's faster
        than supplying a full list to compgen.
      - Remove arguments completion for 'config-dump' subcommand, it does not
        accept arguments since 2.0.0~alpha1.
      - Complete also option names after '--option' and '-o'.
  * downloadmethods:
    - Added '--as-needed' to link flags.
  * debian:
    - control:
      - Build-depend on 'txt2tags'.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 09 Apr 2011 18:28:51 +0300

cupt (2.0.0~beta2) experimental; urgency=low

  * console:
    - Action preview prompt: support 'ProcessTriggers' action.
    - New experimental subcommand 'tar-metadata'.
    - 'showsrc':
      - Output also Uploaders when not empty. Fixes a regression introduced
        in 2.0.0~alpha1.
    - When selecting a version by archive/codename, throw an error if more
      than one matching version is found.
  * lib:
    - cache/binaryversion:
      - 'isInstalled': fixed crash when a version has no sources.
    - system/resolvers/native:
      - Don't attempt to synchronize installed versions, reverting to the
        behavior of cupt 1.x.
      - Optimized solutions' selecting and dropping.
      - Reduced a bit CPU and RAM overhead when tracking reasons is on.
      - Clean and verify the solution only before the proposing.
    - system/resolver:
      - 'SynchronizationReason': added the field 'version'.
      - 'SynchronizationReason': renamed the field 'packageName' to
        'relatedPackageName'.
    - system/worker:
      - 'updateReleaseAndIndexData': release the lock only after post-actions
        are run.
      - 'updateReleaseAndIndexData': honor the option
        'apt::get::list-cleanup'. (Closes: #610285)
      - 'Action': new value 'ProcessTriggers'.
      - Now tries to run all triggers before the main action set.
    - system/state:
      - Don't give an error anymore on packages in 'triggers-awaited' and
        'triggers-pending' states. (Closes: #602263)
    - config:
      - Recognize the option 'apt::get::list-cleanup'.
    - cache:
      - Fixed extracting release version from Release files. This regression
        was introduced in 2.0.0~alpha1.
  * debian:
    - changelog, control: source package is back to 'cupt' from 'cupt2'.
    - *: removed the suffix '-experimental' from binary package names.
    - control:
      - Added needed Conflicts against obsolete packages.
      - Changed sections of 'libcupt2-dev' and 'libcupt2-doc' as suggested
        by lintian.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 20 Mar 2011 12:17:28 +0200

cupt (2.0.0~beta1) UNRELEASED; urgency=low

  * console:
    - shell:
      - Restore initial config after every command.
      - Fixed "eating" some one-letter options.
    - Action preview prompt:
      - For removed/purged packages which have an 'automatically installed'
        flag set, append '(a)' to package names.
      - Added an ability to specify additional package expressions and restart
        the solving process (choice 'a'). (Closes: #605416)
      - Treat downgrades as dangerous actions.
      - Ask for the confirmation for dangerous actions only if user has
        accepted the solution.
      - Added a help command.
  * lib:
    - system/resolver:
      - New result type 'Offer'.
      - 'Offer': provide the info about unsatisfied soft dependencies.
      - 'Reason': new method 'toString'.
    - system/resolvers/native:
      - Filter out changes of conflicting packages which don't
        effectively change the situation.
      - Use only reliable information from source packages for synchronizing
        source versions.
      - Reworked underlying data structures.
      - New configurable score calculation system.
      - Do not additionally stick packages except of changed ones, it may hide
        some solution in very rare cases. Fixes a regression since 0.2.2.
      - When no solutions were found, throw an error with a solution tree to
        show why.
      - 'resolve': fixed a wrong result when being called multiple times on
        the same object.
      - 'resolve': added a warning about dropped solutions.
    - config:
      - Deleted option
        'cupt::resolver::synchronize-source-versions::exceptions'.
      - Deleted option 'cupt::worker::archives-space-limit::tries'.
      - New option group 'cupt::resolver::tune-score::*'.
    - system/worker:
      - Fixed not changing 'automatically installed' flag. This regression
        was introduced in 2.0.0~alpha3.
      - Fixed determining an empty extension of index files. This regression
        was introduced in 2.0.0~alpha1.
      - Don't use randomization anymore for implementing
        'cupt::worker::archives-space-limit' option.
      - When breaking changes to changesets, made sure that all subgroups of
        the same group are placed to the same changeset.
      - When purge option is used, don't auto-purge not changed packages in
        the state 'config-files'. Fixes a regression introduced in
        2.0.0~alpha1.
      - When purge option is used, do removal instead of purge for packages
        removed by resolver and not by user.
      - Reorganized 'ActionsPreview' structure.
      - 'setDesiredState': use Resolver::Offer as an argument.
      - 'updateReleaseAndIndexData': use long alias, not short one in the
        'signature verification failed' warning message.
    - common:
      - compareVersionStrings: fixed sorting letters before other characters.
        This regression was introduced in 2.0.0~alpha1.
    - cache:
      - 'getPin': increased downgrade penalty in 5 times.
  * downloadmethods:
    - wget:
      - Fixed passing environment variables to wget process.
  * debian:
    - copyright:
      - Updated copyright years.
    - control:
      - Updated the git branch in the Vcs-Browser link.
    - debian/cupt-experimental.docs:
      - Added to install 'NEWS' file.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 06 Mar 2011 15:22:47 +0200

cupt (2.0.0~alpha3) UNRELEASED; urgency=low

  * All the non-experimental functionality from cupt 1.x is now implemented.

  * console:
    - Fixed non-working binary-to-source mapping in source package version
      expressions.
    - Disallow matching options by prefix. Fixes a regression since
      2.0.0~alpha1.
    - 'snapshot': implemented.
  * lib:
    - cache/binaryversion:
      - 'parseFromFile': 10-25% speed-up.
    - file:
      - 'getRecord': removed parameter 'accepter'.
    - system/resolver:
      - 'operator=': forbidden now.
      - Reorganized *Reason struct, transformed to struct hierarchy.
    - system/resolvers/native:
      - Apply essential package penalty only for removals.
      - Version priorities don't affect versions' scores anymore.
    - system/worker:
      - 'operator=': forbidden now.
      - 'markAsAutomaticallyInstalled': renamed to
        'setAutomaticallyInstalledFlag'.
      - 'deleteArchive': fixed possible directory traversal.
      - Implemented snapshot-related methods.
      - Rewrote scheduling dpkg actions to automatically determine packages
        which need an indirect upgrade, making the option
        'cupt::worker::allow-indirect-upgrade' unneeded.
      - Introduce dpkg action priority heuristics to reduce the time from
        the package state is changed till the package state is final.
    - config:
      - Option 'cupt::resolver::max-solution-count': increased default value
        from 256 to 512.
      - Specified the 'quiet' option as '0' to make apt-listchanges work (a
        work-around for #604130).
      - New method 'getPath' for unified handling of path options.
      - New option 'cupt::directory'.
      - Fixed parsing '#' and '//' strings inside the option values.
      - Deleted option 'cupt::worker::allow-indirect-upgrade'.
    - system/snapshots:
      - Implemented.
    - cache/relation:
      - All single-parameter constructors are now explicit.
  * debian:
    - rules:
      - Fixed installing bash completion script.
  * doc:
    - reference:
      - Documented dynamic library parts. All library is documented now.
    - cupt-experimental.1:
      - '--installed-only' works under 'shell' subcommand since 2.0.0~alpha1.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Thu, 06 Jan 2011 12:35:15 +0200

cupt (2.0.0~alpha2) UNRELEASED; urgency=low

  * console:
    - 'why': fixed infinite CPU and RAM usage when some of starting versions
      have a dependency cycle with any other version.
  * lib:
    - hashsums:
      - 'getStringHash': speed-up.
      - 'getStringHash': renamed to 'getHashOfString'.
      - 'getHashOfString': fixed crash on non-ASCII strings.
      - Use libgcrypt for hash computations.
    - cache:
      - Pre-parsing index files: really discard packages with broken package
        names.
      - 'operator=': forbidden now.
      - Refusing expired Release files: use a workaround to parse expiry date
        as UTC time, not local time.
    - file:
      - 'getBlock': renamed to 'getRecord'.
      - destructor: check child exit status in a pipe mode.
    - common:
      - 'exception': renamed to 'Exception'.
    - system/resolvers/native:
      - Don't add new reason to an action which received unsatisfied soft
        dependency penalty.
    - config:
      - 'getNumber': renamed to 'getInteger'.
    - cache/version:
      - 'AvailableAsEntry': renamed to 'Source'.
      - 'availableAs': renamed to 'sources'.
    - download/progress:
      - 'progress': fixed nasty bug with wrong computing total download
        size when at least one download has an unknown size.
      - 'finish': renamed to 'finishHook' and moved to protected section.
      - 'getOverallEstimatedTime': now returns time since the start of the
        download session, not from the current moment.
      - don't include '<ctime>' header anymore.
    - Link with 'rt'.
    - cache/relation:
      - 'unarchitectureRelationLine': moved to ArchitecturedRelationLine class
        and renamed to 'toRelationLine'.
      - 'ArchitecturedRelationExpression::getHashString': doesn't exist,
        removed its declaration.
    - cache/package:
      - 'operator=': forbidden now.
      - copy constructor: forbidden now.
    - system/worker:
      - Fixed typo which resulted in some action dependencies being lost while
        merging remove and unpack actions.
      - Fixed typos which resulted in many false positives when checking for
        temporary broken pre-depends.
    - download/manager:
      - Added multiple inclusion guards to the header.
      - If download method reported expected download file size after a
        download was started, pass it to download progress object.
    - download/method:
      - 'getNumericAcquireSuboptionForUri': renamed to
        'getIntegerAcquireSuboptionForUri'.
    - download/methodfactory:
      - 'operator=': forbidden now.
    - cache/binaryversion:
      - 'task': removed the field.
  * doc:
    - examples:
      - Added 'show-upgradeable' example.
    - reference:
      - Documented static part of the library.
      - Added a build infrastructure.
      - Documented library's download subsystem (namespace 'cupt::download').
  * debian:
    - rules:
      - Moved starting buildpoint to top directory (from 'cpp').
    - control:
      - Added build-dependency on doxygen.
      - Added new binary package 'libcupt2-doc-experimental'.
      - The package libcupt2-dev-experimental now suggests
        libcupt2-doc-experimental.
      - Added build-dependency on libgcrypt11-dev.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 14 Nov 2010 10:39:41 +0200

cupt (2.0.0~alpha1) UNRELEASED; urgency=low

  * Re-implemented in C++ (and subset of C++0x). (Closes: #605320)
    - Parsing version entries is much faster now. (Closes: #547950)

  * console:
    - The '--installed-only' option now works under 'shell' command.
    - The 'config-dump' subcommand no longer accepts arguments.
  * lib:
    - cache/sourceversion:
      - Support multiple tarballs.
    - config:
      - Implemented issuing detailed error messages when facing syntax errors
        in configuration files.
    - cache:
      - Implemented refusing expired Release files. (Closes: #604543)
  * downloadmethods:
    - wget:
      - Implemented.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 26 Sep 2010 12:31:09 +0300

cupt (1.5.14.1) unstable; urgency=low

  * Cupt:
    - Config:
      - Fixed ignoring 'APT::Never-MarkAuto-Sections' option.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 25 Sep 2010 22:17:33 +0300

cupt (1.5.14) unstable; urgency=low

  * doc:
    - cupt_vs_apt:
      - Documented not handling the difference between 'specific' and
        'general' APT pin types. (Closes: #586347)
  * Cupt:
    - Cache:
      - ArchitecturedRelation:
        - Implemented architecture wildcards support. (Closes: #587354)
  * debian/control:
    - Bumped Standards-Version to 3.9.0, no changes needed.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Thu, 08 Jul 2010 21:20:35 +0300

cupt (1.5.13) unstable; urgency=low

  * Cupt:
    - Cache:
      - Reading APT preferences: handle multiple package names, separated by
        spaces, correctly. Thanks to Julian Andres Klode for the report.
        (Closes: #585017)
    - System:
      - Worker:
        - Fixed passing version comparison result for pre-install hooks of
          version 2 in case of removals, re-installs and downgrades.
        - In case of circular actions error, suggest to add failed packages
          to 'cupt::worker::allow-indirect-upgrade' option.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Mon, 14 Jun 2010 21:45:29 +0300

cupt (1.5.12) unstable; urgency=low

  * Cupt:
    - System:
      - Worker:
        - Ignore Replaces when building new dependency edge because of
          Conlifcts. Dpkg purposedly violates the §7.6.2 of Debian policy.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 23 May 2010 16:43:41 +0300

cupt (1.5.11) unstable; urgency=low

  * Cupt:
    - Cache:
      - Parsing preferences: silently ignore files in preferences directory
        that don't conform to apt_preferences(5). Thanks to Eduard Bloch.
        (Closes: #578681)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 02 May 2010 19:57:11 +0300

cupt (1.5.10) unstable; urgency=low

  * cupt
    - 'why': if received only one argument, assume --installed-only.
      Thanks to James Vega for spotting. (Closes: #577646)
    - 'show': add '(on hold)' to the 'Status' line if the package is on hold.
  * Cupt:
    - Download:
      - Manager:
        - Use ITIMER_VIRTUAL instead of ITIMER_REAL for ping signals.
        - Use dedicated pipe in ping signal handler. I believe, it
          Closes: #554620. Many thanks to James Vega.
    - Cache:
      - 'verify_signature': rewrote error handling, added missing input
        checks.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 18 Apr 2010 11:02:47 +0300

cupt (1.5.9) unstable; urgency=low

  * cupt:
    - help:
      - Clarified that 'safe-upgrade' command can remove automatically
        installed packages. Thanks to intrigeri@boum.org. (Closes: #575702)
    - Action preview prompt:
      - Display a warning in case of packages on hold to be modified.
  * Cupt:
    - Cache:
      - 'get_pin': obey version holds by default by honoring new
        'cupt::cache::obey-hold' option. Thanks to intrigeri@boum.org.
        (Closes: #575704)
      - Package:
        - Don't check binary architecture for installed packages. Thanks to
          Julian Andres Klode for the report. (Closes: #574819)
    - Config:
      - ISCConfigParser:
        - Allow '.' character in option names. Thanks to intrigeri@boum.org.
          (Closes: #575715)
      - Recognize 'apt::get::build-dep-automatic' option.
      - New 'cupt::cache::obey-hold' option.
    - System:
      - Worker:
        - Set the process umask to 022. Thanks to intrigeri@boum.org.
          (Closes: #575700)
    - Download:
      - Method:
        - 'get_acquire_suboption_for_uri': setting
          'acquire::<protocol>::[<host::]proxy' to "DIRECT" to disable it
          is now supported too.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 03 Apr 2010 17:56:29 +0300

cupt (1.5.8) unstable; urgency=low

  * Cupt:
    - Cache:
      - Fixed potential crash if some chunk in the index file doesn't contain
        valid Package line.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 20 Mar 2010 15:57:19 +0200

cupt (1.5.7) unstable; urgency=low

  * Cupt:
    - Config:
      - Added packages 'openoffice.org-common', 'openoffice.org-java-common',
        'openoffice.org-writer2latex' to the list of packages which are to be
        upgraded indirectly. Thanks to Michael Stapelberg. (Closes: #573038)
  * debian/control:
    - Bumped Standards-Version to 3.8.4, no changes needed.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 13 Mar 2010 09:37:37 +0200

cupt (1.5.6) unstable; urgency=low

  * Cupt:
    - Cache:
      - 'verify_signature': detect 'no public key' error from gpgv and display
        better error message in this case.
      - 'verify_signature': don't throw fatal error on unexpected messages
        from gpgv. Thanks to Jean-Christophe Dubacq for the report.
        (Closes: #570196)
      - 'verify_signature': recognize 'KEYEXPIRED' gpgv message in addition to
        'EXPSIG' and 'EXPKEYSIG' ones.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 20 Feb 2010 15:17:10 +0200

cupt (1.5.5) unstable; urgency=medium

  * Cupt:
    - Cache:
      - Parsing extended states: fixed exiting with error on empty file
        (a regression since 1.5.4). Fixes FTBFS. (Closes: #569387).
        Urgency is set to 'medium' because of this fix.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Thu, 11 Feb 2010 22:04:16 +0200

cupt (1.5.4) unstable; urgency=low

  * Cupt:
    - Cache:
      - Parsing extended states: don't choke on unexpected fields.
    - System:
      - Worker:
        - Scheduling dpkg call sequence: fixed the false positive of
          'unable to schedule circular actions: unpack ..., unpack...' error
          in cases when specified Replaces are enough to "beat" mutual
          conflicts problem.
    - Config:
      - Added the package 'openoffice.org-core' to the list of packages which
        are to be upgraded indirectly.
      - Added the option family 'DSelect::*'. (Closes: #568706)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Mon, 08 Feb 2010 20:36:18 +0200

cupt (1.5.3) unstable; urgency=low

  * Cupt:
    - Download:
      - Manager:
        - Fixed crash when downloading URIs containing mangled symbols in
          debug mode.
    - Cache:
      - When parsing source lists, don't crash if a source line contains only
        one or two words.
    - Config:
      - get_list: return an empty list, not a list of one undefined entry in
        case of non-defined optional option.
    - Worker:
      - Fixed calculating dependencies for 'remove' subactions of upgrade
        actions of indirectly upgradeable packages.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Mon, 01 Feb 2010 20:47:06 +0200

cupt (1.5.2) unstable; urgency=low

  * Cupt:
    - Config:
      - Added packages 'openjdk-6-jre', 'openjdk-6-jre-lib' and
        'openjdk-6-jre-headless' to the list of broken packages which are to
        be upgraded indirectly. (Closes: #567436)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 31 Jan 2010 12:52:07 +0200

cupt (1.5.1) unstable; urgency=low

  * Cupt:
    - System:
      - Worker:
        - 'change_system': perform download stage after determining dpkg call
          sequence.
        - Fixed the stupid long-standing bug with forgetting some action
          dependencies for relation expressions which involve several binary
          packages. Thanks to James Vega for spotting it. (Closes: #564724)
      - Resolvers/Native:
        - Significantly increased the penalty for removing installed packages.
        - Optimize building solution tree in case of actions that resolve
          conflicts with multiple packages that provide the same virtual
          package.
    - Config:
      - Added the 'aptlistbugs::*' option family. Thanks to Ryan Niebur.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Tue, 12 Jan 2010 14:02:06 +0200

cupt (1.5.0) unstable; urgency=low

  * cupt:
    - 'dist-upgrade': start completely new process in the second stage to fix
      the possible undefined behavior when libcupt-perl got upgrade in the
      first stage with the API changes.
    - 'depends': in recurse mode pick up only one new version for the relation
      expression by default, specify '--all-versions' to override.
  * Cupt:
    - Config:
      - New option family 'cupt::downloader::protocols::*::priority'.
      - New option family 'cupt::downloader::protocols::*::methods'.
      - New option family
        'cupt::downloader::protocols::*::methods::*::priority'.
    - Download:
      - Manager:
        - Sort URIs for the file by priorities.
      - Method:
        - Implemented choosing a method with maximum priority between several
          available ones.
    - System:
      - Resolvers/Native:
        - Adjusted calculating action weights so installing new version
          outweights non-upgrading another package in most cases, even
          automatically installed one. Thanks to James Vega. (Closes: #562797)
  * scripts/bash_completion:
    - Implemented bash completion for cupt program.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 02 Jan 2010 18:03:45 +0200

cupt (1.4.0) unstable; urgency=low

  * Cupt:
    - System:
      - Worker:
        - 'get_unpacked_sizes_preview': fixed a crash when purging the package
          in 'config-files' state but which has installation candidates.
          Thanks to Cyril Brulebois. (Closes: #559340)
      - Resolvers/Native:
        - Fixed the bug when soft dependencies were automatically removed in
          the start of resolving because of disappear of the parent packages
          and then weren't considered to keeping when other parent packages
          hierarchy declared a soft dependency on the package.
        - Apply 'automatically installed' penalty score to all versions of
          automatically installed packages, not only installed one.
        - Don't perform inner auto-removal before of main resolver cycles.
      - Resolvers/External:
        - Request: lowercased all fields.
        - Request: pass '>>' as '>' and '<<' as '<' in relation expressions.
        - Request: added the preable with a 'pin-priority' property
          declaration.
        - Request: 'problem' stanza is renamed to 'request'.
    - Download:
      - Methods/Debdelta:
        - Suppress standard output from debpatch.
    - Config:
      - [API break] 'set_regular_var': renamed to 'set_scalar'.
      - [API break] 'set_list_var': renamed to 'set_list'.
      - [API break] 'var': replaced by new methods 'get_string', 'get_number'
        and 'get_bool'.
    - Core:
      - Moved INIT block out to 'cupt' front-end.
    - Cache:
      - 'verify_signature': use gpgv, not gpg for checking.
      - BinaryVersion:
        - Fallback to 0 if the installed size is not defined. Thanks to
          Jean-Christophe Dubacq <jcdubacq1@free.fr>. (Closes: #560160)
  * debian/control:
    - Added the package 'gpgv' to Recommends of the 'libcupt-perl' package.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Tue, 15 Dec 2009 13:58:38 +0200

cupt (1.3.1) unstable; urgency=low

  * Cupt:
    - Config:
      - Added the option 'APT::Never-MarkAuto-Sections'.
      - Added the option family 'Aptitude::*'.
    - Cache:
      - 'verify_hash_sums': fixed the crash regression since 1.3.0. Thanks to
        Cyril Brulebois. (Closes: #557177)
    - Graph/TransitiveClosure:
      - Fixed calculating vertexes reachability for paths with length more
        than 2.
    - Worker:
      - While splitting heterogeneous actions, pay the first attention to
        action dependencies which are originated from 'Conflicts'. No longer
        pass '--force-conflicts' to dpkg. Thanks to James Vega.
        (Closes: #556650)
      - Mark the 'remove' subactions of upgrade/downgrade actions as fake.
      - Subsequently, don't try to "eat" some action dependencies anymore.
      - Don't merge unpack and configure subactions.
      - While splitting heterogeneous actions, ignore (after setting up
        '--force-breaks' and '--force-depends') reverse dependencies'
        breakages.
      - Allow circular dependencies between only 'configure' subactions, give
        up with an error on other ones.
      - Pass '--force-bad-path' to work around dpkg bug #558151.
    - Download:
      - Progresses/Console:
        - Fixed a divide-by-zero crash with zero-sized files. Thanks to
          James Vega. (Closes: #557661)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Mon, 30 Nov 2009 15:23:28 +0200

cupt (1.3.0) unstable; urgency=low

  * cupt:
    - 'rdepends': memoize parsed versions.
    - Management actions:
      - Support '@<file>' syntax for reading arguments from files. The idea of
        the patch by Jean-Christophe Dubacq. (Closes: #554356)
    - Don't crash when run with no parameters (once again). Thanks to
      Didier Raboud. (Closes: #547952)
  * Cupt:
    - Cache:
      - 'get_satisfying_versions': don't sort result.
      - 'get_sorted_pinned_versions': removed ability to memoize it.
      - BinaryVersion:
        - Rewritten parsing the version entry using different approach.
          Speeded up parsing significantly.
        - New field 'others'.
        - [API break] 'homepage': removed, it now belongs to 'others' if
          supplied.
      - SourceVersion:
        - Rewritten parsing the version entry using different approach.
        - Support 'Binary' field span to multiple lines.
        - Support native packages with dashed version strings with a warning.
        - Recognize ".debian.tar.<ext>" files as diffs.
        - New field 'others'.
        - [API break] 'uploaders': became reference to array instead of string.
    - System:
      - Resolvers/Native:
        - Don't pre-schedule any relations for newly-installed versions, leave
          all work to main resolver. Also (Closes: #555209)
        - Don't try to remove the same unsynchronizeable package multiple
          times.
        - Fixed 'full' flavor of the resolver in non-debug mode.
        - Fixed too high factor for deleting unsynchronizeable packages.
        - Implemented shallow copying for solutions. Significantly reduces
          the average RAM footprint for a solution.
        - Don't try to remove the unsynchronizeable package if the stick is
          set.
        - Adjusted calculating action weights so installing an extra package
          gains almost nothing.
        - When 'cupt::resolver::synchronize-source-versions' is set, try use
          source versions if available to speed-up processing.
        - Don't perform re-synchronization if the source version has several
          appropriate binary versions.
        - Adjusted the effect of the 'cupt::resolver::quality-bar' option so
          it affects the less the longer solution is.
        - Significatly increased the penalty for non-installing the requested
          soft dependencies.
        - Implemented internal dependency graph to speed up processing
          solutions.
      - Worker:
        - Don't use File::Path module. Thanks to Bernd Zeimetz.
          (Closes: #553629)
        - Check that 'cupt::worker::archives-space-limit' is numeric. Thanks
          to Cyril Brulebois.
        - While splitting heterogeneous actions, set '--force-breaks' to all
          non-trivial actions in addition to '--force-depends'.
          Thanks to James Vega. (Closes: #556014)
        - Pass '--force-conflicts' to 'install' subaction of heterogeneous
          actions, the intermediate conflicts can still exist.
    - Config:
      - Fixed the typo to properly don't check option names for all
        'unattended-upgrade::*' options. Thanks to Jean-Christophe Dubacq.
        (Closes: #547951)
      - Changed the default value of the 'cupt::resolver::quality-bar' option
        from -250 to -50.
  * debian/control:
    - Restricted dependency of cupt on libcupt-perl to match minor version.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 15 Nov 2009 22:13:59 +0200

cupt (1.2.1) unstable; urgency=medium

  * cupt:
    - 'screenshots':
      - Launch a browser in "background" to display more than two packages
        simultaneously. Thanks to Pavel Chernyshev.
  * Cupt:
    - System:
      - Resolvers/Native:
        - Speeded up applying changes when only one resolution (in the
          solution thread) available.
    - Config:
      - Changed the default value of the 'cupt::resolver::quality-bar' option
        from -400 to -250 to prevent producing somewhat bad solutions under
        rare circumstances.
  * debian/control:
    - Added liblist-moreutils-perl to build-depends. Fixes FTBFS.
      Thanks to Lucas Nussbaum. Urgency is set to medium. (Closes: #552948)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Fri, 30 Oct 2009 12:04:26 +0200

cupt (1.2.0) experimental; urgency=low

  * cupt:
    - New 'snapshot' subcommand.
    - 'satisfy':
      - Fixed taking architecture specifiers from the command-line into
        account.
  * Cupt:
    - Config:
      - New configuration option 'cupt::directory::state'.
      - New configuration option 'cupt::directory::state::snapshots'.
      - New configuration option 'cupt::worker::archives-space-limit'.
      - New configuration option 'cupt::worker::archives-space-limit::tries'.
    - System:
      - Worker:
        - Removed "locking" /var/lib/dpkg/lock, it's useless (noop).
        - Implemented Cupt lock.
        - New method 'save_system_snapshot'.
        - New method 'remove_system_snapshot'.
        - New method 'rename_system_snapshot'.
        - Do some reordering of generated dpkg call sequence to make
          'unpack' actions appear as late as possible.
        - 'change-system': honor 'cupt::worker::archives-space-limit' option.
      - Snapshots:
        - Introduced.
    - Cache:
      - New method 'get_path_of_extended_states'.
  * debian/control:
    - Added 'dpkg-dev' and 'dpkg-repack' to Suggests.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Tue, 27 Oct 2009 18:41:50 +0200

cupt (1.1.1) unstable; urgency=low

  * cupt:
    - 'search':
      - Fixed crash with '-n' option introduced in 1.1.0.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Fri, 23 Oct 2009 17:40:30 +0300

cupt (1.1.0) unstable; urgency=high

  * cupt:
    - Memoize parsed versions when managing packages and in shell mode.
      Reduced peak RAM usage by resolver. Reduced time spent in native
      resolver for non-trivial solutions.
    - Managing packages:
      - New option '--assume-yes|--yes|-y'.
    - New 'reinstall' subcommand.
  * Cupt:
    - Graph:
      - Introduced as reduced and optimized for Cupt re-implementation
        of some methods of Graph class.
    - System:
      - Worker:
        - Changed to work with Cupt::Graph module instead of CPAN Graph.
          Dramatically reduced time needed to generate dpkg call sequence in
          'change_system' method. Significantly reduced peak RAM usage in
          'change_system' method.
        - Honor the configuration option
          'cupt::worker::allow-indirect-upgrade' to work around packages with
          broken-by-design dependencies that make the package unupgradeable.
          Thanks to James Vega. Upload priority is set to 'high' due to this
          fix. (Closes: #551831)
      - Resolvers/Native:
        - Changed to work with Cupt::Graph module instead of CPAN Graph.
        - When determining whether related binary packages may be synchronized
          for 'cupt::resolver::synchronize-source-versions' option, fix
          possibly incorrect positive answer when there are at least 2 related
          binary packages and some of them have the same source version as
          the original binary package.
        - Prepare stick requests after possible dropping solutions due to
          'cupt::resolver::synchronize-source-versions' set to 'hard'. Gives
          more room for upgrades in some cases.
        - Honor the 'cupt::resolver::synchronize-source-versions::exceptions'
          configuration option.
        - When 'cupt::resolver::synchronize-source-versions' set to 'hard',
          allow removal of unsynchronizeable packages.
      - State:
        - Don't store version strings of installed packages, but request them
          from cache when needed.
    - Cache:
      - [API break] 'get_binary_packages': superseded by new
        'get_binary_package_names' method.
      - [API break] 'get_source_packages': superseded by new
        'get_source_package_names' method.
      - Create Cupt::Cache::Package objects only by demand. Reduced time to
        build a cache by 5-10%.
      - 'new': added the switch '-allow-reinstall'. 
      - Package:
        - Changed internal structure to hold additonal parameters.
        - [API break] 'o_binary_architecture': removed, not needed anymore.
        - New module option 'o_memoize' to memoize parsed versions.
    - Config:
      - Added the configuration variable 'apt::get::assume-yes'.
      - New configuration option 'cupt::console::assume-yes'.
      - New configuration option 'cupt::console::allow-untrusted'.
      - New configuration option
        'cupt::resolver::synchronize-source-versions::exceptions'.
      - New configuration option 'cupt::worker::allow-indirect-upgrade'.
  * Makefile.PL, debian/control:
    - Dropped the dependency on libgraph-perl.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Thu, 22 Oct 2009 11:42:58 +0300

cupt (1.0.0) unstable; urgency=low

  * cupt:
    - Action preview prompt:
      - Output also 'Suggests' relation expressions in 'leave unresolved'
        check.
      - Output unresolved dependencies for a dependency group <dep> only if
        the option 'cupt::resolver::keep-<dep>' is set to true.
    - Managing packages:
      - Fixed shell wildcards when scheduling removal of packages which
        are not installed.
  * Cupt:
    - Cache:
      - 'get_original_apt_pin': fixed clashing values which are
        substrings of other pin settings. Thanks to Jameson Graef Rollins
        <jrollins@finestructure.net>. (Closes: #549423)
    - System:
      - Worker:
        - Preparing downloads: don't attempt to create a directory for partial
          downloads when it doesn't exist and simulate mode is on.
  * doc:
    - cupt_vs_apt:
      - Mentioned 'cupt::update::compression-types' in differences.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Wed, 14 Oct 2009 18:25:27 +0300

cupt (1.0.0~rc1) unstable; urgency=low

  * cupt:
    - Don't crash when run with no parameters (again). Thanks to Patrick
      Schoenfeld. (Closes: #547952)
    - If the command isn't supplied, act as it was 'help'. Thanks to Patrick
      Schoenfeld for the suggestion.
    - 'shell':
      - Added extra space to the cupt shell prompt. Thanks to to Patrick
        Schoenfeld for the suggestion. (Closes: #548008)
      - Print help output if user typed only '?' as a command in a shell
        session. Thanks to to Patrick Schoenfeld. (Closes: #548010)
    - 'config-dump':
      - Print a semicolon after each option value.
      - Print values of list options in parseable form.
    - Managing packages:
      - Destroy resolver just after it produced a solution for worker.
        Reduces peak RAM usage by 1-2%.
  * Cupt:
    - Config:
      - Recognize 'apt::periodic::*' variables.
      - Recognize 'unattended-upgrade::*' variables.
      - Recognize 'apt::archives::*' variables.
      - Three above accidentally (Closes: #547951).
      - Report unknown option names in original case. Thanks to Robert Millan.
        (Closes: #548314)
      - New option family 'cupt::update::compression-types::*::priority'.
      - ISCConfigParser:
        - Parse \" as " in values. Thanks to Julian Andres Klode.
        - Fixed parsing non-first nested structures. Thanks to
          Oleg Tsybulskyi <alogic0@gmail.com>.
        - Implemented '#clear' directive.
    - Cache:
      - Strip last '/' character from base URI if present. Thanks to Patrick
        Schoenfeld. (Closes: #547953)
      - Parsing preferences: allow spaces between release expressions.
        Thanks to Julian Andres Klode. (Closes: #548051)
      - Speeded up 'Provides' pre-parsing. Reduced 15-25% of overall cache
        build time.
      - SystemState:
        - Speeded up 'Provides' pre-parsing. Reduced 5-10% of overall cache
          build time.
      - Package:
        'new': reduced 10-15% of time spent.
      - BinaryVersion:
        - 'new': fixed reading installed size in bytes.
        - 'new': use internal offsets for working with fields, reduces time
          spent by 20-30%.
        - 'new': verify that architecture is specified. (Closes: #548710)
    - Download:
      - Manager:
        - Added internal check for undefined results from post-action
          subroutines.
      - Progresses/Console:
        - Make sure that guessed terminal width is >= 80 characters.
    - System:
      - Worker:
        - 'update_release_and_index_data': fixed race condition when
          'cupt::update::keep-bad-signatures' is set to false, some release
          signature failed gpg check, and more than one index file is attached
          to corresponding Release.
        - 'update_release_and_index_data': honor new
          'cupt::update::compression-types::*::priority' options.
      - Resolvers/Native:
        - Print debug information when some solution path cannot be taken
          because of 'cupt::resolver::synchronize-source-versions' option set
          to 'hard'.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 03 Oct 2009 11:03:47 +0300

cupt (1.0.0~beta1) unstable; urgency=low

  * cupt:
    - Fixed the regression since 0.6.0 when reasons are selected to display
      and some reason is an unsatisfied pre-dependency. Thanks to
      Michael Stapelberg.
  * Cupt
    - Cache:
      - Require List::MoreUtils >= 0.23 directly in code too. Thanks to
        Michael Stapelberg for the suggestion.
    - System:
      - Worker:
        - Sort downloads alphabetically.
        - 'update_release_and_index_data': flip the return result to match the
          documentation.
        - 'update_release_and_index_data': honor
          'apt::update::post-invoke-success' option.
        - 'update_release_and_index_data': don't try to check signatures in
          simulate mode.
      - Worker:
        - 'change_system': produce more debug info when calling dpkg.
        - While splitting heterogeneous actions, set '--force-conflicts' dpkg
          option for unpack/install commands with more than one package as
          an argument even for safe-as-a-whole operations.
    - Config:
      - Added configuration variable 'apt::update::post-invoke-success'.
  * doc:
    - cupt_howto:
      - Added a paragraph with debug options to use when reporting problems.
  * debian/rules:
    - Fixed building with Perl 5.10.1.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Mon, 21 Sep 2009 15:12:50 +0300

cupt (0.6.5) unstable; urgency=low

  * cupt:
    - 'dist-upgrade': fixed the regression since 0.6.4 being not able to
      proceed package management tools upgrade successfully.
    - The option '--no-install-unpacked' went away. Now the all the packages
      within some interim state are scheduled for installation, but with no
      stick, so one can easily install other versions or delete them
      explicitly.
  * Cupt:
    - Download:
      - Manager:
        - Honor 'cupt::worker::simulate' option in the native way.
        - [API break] Advanced input parameters for 'download' subroutine to
          include optional short and long aliases.
        - [API break] Removed 'set_short_alias_for_uri' subroutine.
        - [API break] Removed 'set_long_alias_for_uri' subroutine.
    - System:
      - State:
        - Consider all packages except in states 'not-installed' and
          'config-files' as installed. They are full-right participants of
          dependency and worker management.
      - Worker:
        - Create partial directory for downloads when it doesn't exist.
          Thanks to Cyril Brulebois.
        - Don't try to check hash sums of Packages/Sources when no local file
          exists while deciding should we download Packages/Sources or not.
          Thanks to Cyril Brulebois. Thanks to James Vega.
          (Closes: #545685)
        - While splitting heterogeneous actions, set '--force-depends' dpkg
          option for commands with more than one package as argument even for
          safe-as-a-whole operations. Dpkg cannot handle gracefully them now
          in some cases. Thanks to James Vega. (Closes: #545496)
    - Config:
      - New option 'cupt::resolver::quality-bar'.
      - Added option 'apt::get::automaticremove'.
      - Added option 'apt::get::purge'.
      - Recognize option 'apt::get::show-upgraded'.
  * debian/control:
    - Updated my mail address.
    - Inserted versioned dependency on liblist-moreutils-perl (>= 0.23).
      Earlier versions had tricky bug in 'none' subroutine. Thanks to
      Cyril Brulebois.
    - Removed 'DM-Upload-Allowed' field, it's not needed anymore.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 13 Sep 2009 09:52:04 +0300

cupt (0.6.4) unstable; urgency=low

  * Cupt:
    - Config:
      - Recognize new APT 'acquire::compressiontypes::*' variables.
    - Download:
      - Methods/Curl:
        - Delete partially downloaded file and restart download if the server
          don't support resuming. Thanks to Bernd Zeimetz. (Closes: #544186)
    - System:
      - Resolvers/Native:
        - Display descriptive error message when manually selected version of
          package cannot be updated because of the option
          'cupt::resolver::synchronize-source-versions' set to 'hard'.
        - Don't fail to synchronize already sticked binary package with the
          same source version.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Mon, 31 Aug 2009 23:59:45 +0300

cupt (0.6.3) unstable; urgency=medium

  * cupt:
    - Don't crash on actions confirmation when the user answer is not
      available (end of file, read error etc.)
  * Cupt:
    - Download:
      - Methods/Curl:
        - Enable sharing cookies database and DNS cache for multiple
          downloads.
    - System:
      - Resolvers/Native:
        - Fixed a very tricky regression since 0.6.0 with passing status of
          packages to worker that causes the situation that some of
          automatically installed packages are not marked as such. If you
          installed something big with 0.6.{0-2} libcupt-perl versions, you
          will need to go and mark needed packages as automatically installed
          manually (e.g. using 'cupt markauto'). Sorry for the inconvenience.
          The urgency is set to 'medium' because of this fix.
  * doc/cupt_vs_apt:
    - Renewed to reflect changes in apt 0.7.23.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Thu, 27 Aug 2009 22:11:20 +0300

cupt (0.6.2) unstable; urgency=low

  * cupt:
    - New 'dist-upgrade' subcommand.
    - 'search':
      - Fixed the crash when some short description is not present.
        Thanks to James Vega. (Closes: #543598)
    - 'show':
      - Fixed the crash when some short description is not present.
  * Cupt:
    - System:
      - Worker:
        - Significant speed-up of run-time pre-dependency check.
        - Significant speed-up of processing the virtual action dependencies.
    - Cache:
      - Support 'none' value of the 'apt::acquire::translation' option.
    - Download:
      - Methods/Debdelta:
        - Explicitly pass new '--accept-unsigned' option to debdelta. We don't
          need debdelta signatures as resulted package is still checked using
          hash sums.
  * doc/*.pod:
    - Explicitly specified UTF-8 encoding. Patch by James Vega.
      (Closes: #543706)
  * debian/control:
    - libcupt-perl don't support debdelta (<< 0.31) anymore because of new
      debdelta signatures. Set Breaks accordinly.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Wed, 26 Aug 2009 20:13:30 +0300

cupt (0.6.1) unstable; urgency=low

  * Cupt:
    - Cache:
      - ArchitecturedRelation:
        - 'stringify': the architectures separator is the space, not the
          comma.
    - System:
      - Worker:
        - Turned the run-time pre-dependency check into a warning. One cannot
          surely say whether it's an error or not. Thanks to James Vega.
          (Closes: #543365)
  * debian/control:
    - The package 'libcupt-perl' now depends on 'liblist-moreutils-perl'.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Mon, 24 Aug 2009 23:22:32 +0300

cupt (0.6.0) unstable; urgency=low

  * cupt:
    - New 'version' (aliases: '--version', '-v') subcommand.
    - New 'help' (aliases: '--help', '-h') subcommand. (Closes: #540790)
    - 'showsrc':
      - Don't assume any of hash sum of package to de defined, check it.
        Thanks to Cyril Brulebois. (Closes: #541470)
    - New 'why' subcommand.
    - 'show':
      - Fix typo in code determining which hash sums are present.
    - 'satisfy':
      - Implemented unsatisfying relation expressions (by appending the minus
        sign) too.
    - 'rdepends':
      - Pre-build reverse dependencies index at start. Reduces time of
        one-shot rdepends call by ~2 times and dramatically reduces overall
        time in case of recursive rdepends.
  * Cupt:
    - Cache:
      - Package:
        - Fixed another crash when merging two source versions with equal
          version strings. Thanks to Cyril Brulebois.
      - BinaryVersion:
        - Fixed reading 'Task' field.
        - Don't warn on non-existent 'Priority' field, policy does not
          mandate it.
      - SourceVersion, BinaryVersion:
        - [API break] Changed internal storage from hash to array, introduced
          mutator methods (fields). Documented all fields.
        - Don't choke if 'Section' field is not defined.
        - [API break] The field 'avail_as' has been renamed to 'available_as'.
      - ArchitecturedRelation:
        - 'unarchitecture_relation_expressions': fixed skipping architectures
          for [!a !b ... !z] cases. Thanks to Cyril Brulebois.
          (Closes: #542609)
    - System:
      - Resolvers/Native:
        - Don't synchronize source packages if the option
          'cupt::resolver::synchronize-source-versions' is set to 'none'.
        - Fixed a minor regression since 0.3.0 in determining version weight,
          including "essentialness" of the version.
        - Fixed a crash when performing a deep search for versions that have
          other than original version have, but still satisfiable
          pre-dependency relation expression.
        - Check Recommends/Suggests only when all hard dependencies are
          satisfied.
        - Resolver doesn't unconditionally pre-install Recommends and/or
          Suggests of manually installed/upgraded/downgraded packages
          (if 'apt::install-recommends' and 'apt::install-suggests' turned on,
          respectively) anymore. This change has two main consequences:
          + The common pinning/resolver rules are now applied to
            Recommends/Suggests of manually specified packages too. Besides of
            grown inner flexibility, you can now pin out specific packages or
            versions you don't like.
          + If you upgrade/downgrade the package which has unsatisfied
            Recommends/Suggests and the old and new version of the package
            has the same relation expression, resolver won't try to change
            anything.
      - Worker:
        - Don't pass --force-conflicts to 'install' subaction of heterogeneous
          actions, all conflicts should be already resolved at that stage.
        - Perform unconditional merge if 'unpack' action is dependent
          (directly or indirectly) on appropriate 'configure' one.
        - Detect the packages that break Pre-Depends in inavoidable way, list
          them and exit with an error.
        - Fixed a crash while re-checking hash sums of existing archives
          (introduced after 0.5.2). Thanks to Cyril Brulebois.
          (Closes: #542612)
    - Core:
      - 'version_string_regex': allow debian part of the version contain '_',
        however Cupt::Cache::Package will print a warning in this case.
        (Closes: #541268)
  * debian/control:
    - Made 'cupt' binary package depend on sensible-utils which is not
      essential.
    - Bumped 'Standards-Version' to 3.8.3, no changes needed.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Fri, 21 Aug 2009 21:25:43 +0300

cupt (0.5.2) unstable; urgency=low

  * cupt:
    - Fixed a regression since 0.5.1 when using '+' and '-' expression
      suffixes.
  * Cupt:
    - System:
      - Worker:
        - While building action dependencies graph, deal properly with
          'abc' depends on 'x | y | ...' cases when 'x' is going to be
          removed and 'y' is going to be installed. Thanks to Daniel Moerner.
          (Closes: #539953)
        - While building action dependencies graph, ensure that if the action
          dependency has even one "not eat" property it won't be lost even in
          complicated merge scenarios (Closes: #540957).
        - While splitting heterogeneous actions, don't require additional dpkg
          flags not for 'configure' action, but for last one, which may differ.
    - Config:
      - Added configuration option 'dir::etc::preferencesparts'.
    - Cache:
      - Honor 'dir::etc::preferencesparts' option.
    - Download:
      - Manager,Method,Methods/Debdelta:
        - Implemented debdelta integration. Big thanks to A Mennucc1.
      - Progress:
        - New method 'get_overall_downloaded_size'.
      - Progresses/Console:
        - Print also overall downloaded size on exit.
        - Print 'failed to download' messages as warnings, not as errors.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Tue, 11 Aug 2009 12:26:18 +0300

cupt (0.5.1) unstable; urgency=medium

  * cupt:
    - Exit immediately when nothing to do (for management actions).
      Thanks to Didier 'OdyX' Raboud.
    - Shell wildcars '*' and '?' are now supported in binary/source package
      expressions. (Closes: #539732)
  * Cupt:
    - Config:
      - 'set_regular_var': fixed recognizing the value 'false' as false.
        Thanks to Michael Stapelberg. (Closes: #539730)
    - Cache:
      - Package:
        - Fixed a crash when merging two source versions with equal version
          strings. Thanks to Michael Stapelberg.
      - 'policy_version': don't assume that package contains valid versions,
        pre-check it. Thanks to Didier 'OdyX' Raboud.
      - 'get_original_apt_pin': consider only first successful pin match, as
        declared in apt_preferences(5). Thanks to Didier 'OdyX' Raboud.
      - New method 'get_source_packages'.
    - System:
      - Worker:
        - While building dependency graph, also count Conflicts/Breaks that
          belong to packages going to be removed/purged. The urgency is set to
          'medium' because of this fix. Thanks to Michael Stapelberg.
          (Closes: #539729)
    - Download:
      - Methods/File:
        - Support 'copy' scheme, and do full copying only for it. For 'file'
          scheme do only symlinking. Thanks to Michael Stapelberg.
          (Closes: #539733)
    - Core:
      - New free subroutine 'glob_to_regex'.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Tue, 04 Aug 2009 20:58:34 +0300

cupt (0.5.0) unstable; urgency=low

  * cupt:
    - Fixed a regression since 0.4.0 when trying to 'remove' non-installed
      packages (for insuring that they won't be installed).
    - New 'shell' subcommand.
  * Cupt:
    - System:
      - Worker:
        - 'update_release_and_index_data': always delete possible partial
          chunks of Release files and their gpg signatures before downloads.
        - don't even attempt to "eat" the action dependencies
          that were originated by Conflicts/Breaks, doing this could break
          action sequence order. Thanks to Cyril Brulebois. (Closes: #539256)
    - Cache:
      - 'verify_signature': don't error but only warn when gpg doesn't give
        enough info for some reason. Thanks to Cyril Brulebois.
      - don't hardcode archive 'experimental' for Releases that should be
        pinned as 'not for automatic upgrades', but use 'NotAutomatic' flag
        in the Release file instead.
      - New method 'set_config'.
      - BinaryVersion:
        - Fall back with a warning to priority 'extra' if the priority isn't
          specified.
    - Config:
      - Recognize 'acquire::pdiffs' option, though it's unsupported.
      - New method 'clone'.
  * debian/control:
    - Added Vcs-* headers.
    - Bumped debhelper build-dependency to (>= 7.0.50) to use overrides.
  * debian/rules:
    - Simplified defining PERL variable. Patch by Cyril Brulebois.
    - Use $(PERL) instead of 'perl' to install PODs. Patch by Cyril Brulebois.
    - Dramatically reduced size of the rules, thanks to dh7 override magic.
      Patch by Cyril Brulebois.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Sun, 02 Aug 2009 22:13:31 +0300

cupt (0.4.0.1) unstable; urgency=low

  * Typo fix: 'syncroniz*' -> 'synchroniz*'.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Thu, 23 Jul 2009 23:20:01 +0300

cupt (0.4.0) unstable; urgency=medium

  * cupt
    - Allowed to purge packages with no installation candidates.
  * Cupt:
    - System:
      - Worker:
        - 'get_unpacked_sizes_preview': fixed crash when purging a package
          that has no installation candidates.
        - 'update_release_and_index_data': don't check hash sums for indexes
          in simulate mode to "proceed" all actions, not only Release-related
          ones.
      - Resolver:
        - Generate an error when attempting to schedule more than one action
          on the same package.
        - Honor the 'cupt::resolver::synchronize-source-versions' option.
    - Config:
      - Added 'apt::acquire::translation' configuration option.
      - New 'cupt::resolver::synchronize-source-versions' configuration option.
      - The option 'cupt::resolver::defer-triggers' now defaults to false due
        to unfixed dpkg bug (#526774) that can cause upgrade breakage.
    - Cache:
      - BinaryVersion:
        - Implemented localized descriptions support.
      - ArchitecturedRelation:
        - Fixed parsing of architectured relation expressions which contain
          relation sign.
      - Package:
        - Fixed error while parsing 'Architecture: any' source version,
          introduced in version 0.3.2. Urgency is set to 'medium' because of
          this fix.
      - New method 'get_download_entries_of_localized_descriptions'.
    - Core:
      - 'compare_hash_sums': fixed to return true for equal hash sums.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Thu, 23 Jul 2009 22:57:51 +0300

cupt (0.3.3) unstable; urgency=medium

  * Cupt:
    - Cache:
      - Relation:
        - The '>' and '<' compatibility operators now work as really expected.
          Thanks to Ryan Niebur for report. The urgency is set to medium
          because of this fix.
    - Config:
      - [Ryan Niebur] Support APT_CONFIG environment variable.
    - System:
      - State:
        - [Ryan Niebur] Parsing status file: if grep found nothing in the
          file, this is not an error.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Mon, 13 Jul 2009 20:34:02 +0300

cupt (0.3.2) unstable; urgency=low

  * cupt:
    - 'search':
      - Fixed searching in installed packages.
    - 'rdepends':
      - Output also a version of reverse-depending packages.
      - Consider all available versions, not only policy one.
    - 'depends':
      - Consider all available versions, not only policy one.
    - 'source', 'showsrc', 'build-dep':
      - Implemented binary-to-source mapping as second-chance try if supplied
        source package doesn't exist. Thanks to Steve Cotton.
    - 'source':
      - Verify hash sums for .dsc files too.
  * Cupt:
    - Cache:
      - BinaryVersion:
        - Require only one hash sum to be specified.
      - SourceVersion:
        - Require only one hash sum to be specified for each of part.
      - Package:
        - Emit a warning when throwing away duplicating version with
          non-matched hash sums.
        - Introduce 'o_binary_architecture' flag to filter out versions with
          unwanted binary architectures.
      - 'get_original_apt_pin': don't attempt to pin source versions by source
         package names, they are applicable only to binary versions.
      - Parsing release info: don't require codename to be specified.
      - Parsing release info: don't require version to be specified.
      - Parsing release info: don't require description to be specified.
      - 'verify_hash_sums': advanced to verify only hash sums specified in
        parameter.
      - 'get_download_entries_of_index_list': allow all whitespace characters
        between fields.
      - 'get_download_entries_of_index_list': require only one hash sum to be
        specified for each download entry.
      - 'verify_signature': fixed a crash when gpg unexpectedly didn't return
        anything from pipe.
    - Core:
      - New free subroutine 'are_hash_sums_present'.
      - New free subroutine 'compare_hash_sums'.
    - System:
      - Resolvers/Native:
        - Fixed a crash when using 'satisfy_relation_expression' and
          'unsatisfy_relation_expression' methods with
          'cupt::resolver::track-reasons' option enabled.
      - Worker:
        - 'update_release_and_index_data': fixed wrapping errors in child
           processes.
        - 'get_unpacked_sizes_preview': fixed a crash when purging packages in
          'config-files' state.
        - 'change_system': polished to make it able to correctly purge packages
          in 'config-files' state.
        - 'update_release_and_index_data': call update post-actions even there
          were some non-crtical errors in childs.
        - 'update_release_and_index_data': delete dangling partial index files
          if Release file has been changed since the last run of this method.
    - Download:
      - Methods/Curl:
        - Honor 'acquire::retries' option instead of hardcoded one.
    - Config:
      - Added configuration option 'acquire::retries'.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Fri, 10 Jul 2009 15:02:00 +0300

cupt (0.3.1) unstable; urgency=low

  * cupt:
    - New 'policysrc' subcommand.
  * Cupt:
    - Download:
      - Progress:
        - New method 'get_overall_estimated_time'.
      - Progresses/Console:
        - Display estimated time while downloading.
    - Cache:
      - SourceVersion:
        - Don't choke on native Debian source packages.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Sun, 05 Jul 2009 12:30:47 +0300

cupt (0.3.0) unstable; urgency=low

  * cupt:
    - New 'showsrc' subcommand.
    - New 'build-dep' subcommand.
    - New 'source' subcommand.
  * Cupt:
    - Cache:
      - ArchitecturedRelation:
        - Implemented.
      - SourceVersion:
        - Implemented.
      - Package:
        - 'get_versions': generate exception if there are no valid version
          entries for the package.
      - New method 'get_source_package'.
      - 'get_pin': fixed to not attempt to obtain installed version for source
        packages.
      - Parsing source lists: allow all whitespace characters between fields.
        Patch by Didier 'OdyX' Raboud <didier@raboud.com>. (Closes: #535520)
      - Parsing source lists: don't assume that /etc/apt/sources.list exists.
        Thanks to Didier 'OdyX' Raboud <didier@raboud.com>. (Closes: #535600)
      - Parsing source lists: process only files that have '.list' suffix in
        sources.list.d subdirectory.
        Thanks to Didier 'OdyX' Raboud <didier@raboud.com>.
      - New free subroutine 'verify_hash_sums'.
      - Parsing release info: set Label to '' when it's not specified. Fixes
        crash when pinning by label.
        Thanks to Didier 'OdyX' Raboud <didier@raboud.com>.
      - 'get_original_apt_pin': fixed pinning by release properties of several
        versions of the package. Thanks to Didier 'OdyX' Raboud.
    - System:
      - Resolver,Resolvers/Native,Resolvers/External:
        - New method 'unsatisfy_relation_expression'.
      - Resolvers/Native:
        - Don't consider Essential packages as candidates for auto-removal.
          Thanks to Didier 'OdyX' Raboud and Steve Cotton.
        - Fixed considering 'apt::neverautoremove' option when trying to
          auto-remove packages. Thanks to Didier 'OdyX' Raboud.
    - Download:
      - Manager:
        - Worker process: fixed race condition in sending error of the last
          download to progress.
    - Core:
      - 'version_string_regex': allow upstream part of the version start with
        a non-digit symbol, however Cupt::Cache::Package will print a warning
        in this case. Thanks to Steve Cotton. (Closes: #535514)
  * po:
    - getpot: specified UTF-8 encoding for input files, fixing xgettext error.
      Thanks to Frederik Schwarzer <schwarzerf@gmail.com>.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Sat, 04 Jul 2009 19:01:58 +0300

cupt (0.2.3) unstable; urgency=medium

  * Cupt:
    - System:
      - Worker:
        - 'update_release_and_index_data': fixed downloading of non-compressed
          indexes.
        - 'update_release_and_index_data': fixed removing downloaded file after
          uncompressing.
        - 'update_release_and_index_data': remove the downloaded Release.gpg if
          signature verification failed and 'cupt::update::keep-bad-signatures'
          is false (this is the default setting) for the compatibility with APT.
          Thanks to Goswin von Brederlow <goswin-v-b@web.de>.
          (Closes: #533753). Urgency is set to 'medium' because of this fix.
        - 'update_release_and_index_data': download index file even if
          signature download/check failed.
      - Resolvers/Native:
        - Reworked solution rank system.
        - Dropped 'first-good' solution chooser. It can be mimicked by setting
          'max-solution-count' option to 1.
        - Run cleaning auto-installed packages also before resolving, aiming
          to reduce number of solutions resolver should work with.
        - Made "zero" line for actions 400 points less, affecting ordering
          solutions for processing for default 'fair' resolver type. Leads to
          significant (several times) speed-up for some cases. Makes possible
          to obtain at least one solution for some hard queries (like removing
          core system components).
        - Fixed erroneous auto-removing of some dependencies which were brought
          by 'satisfy' query.
    - Download:
      - Manager:
        - Enabled basic HTTPS protocol support.
        - IPC is rewritten using UNIX sockets instead of fifos.
      - Progress:
        - Changed speed-o-meter accuracy to 4 seconds (previous value was
          2 seconds).
      - Methods/Curl:
        - Added basic handling of transitive download errors.
    - Cache:
      - New free subroutine 'verify_signature'.
      - BinaryVersion:
        - [API break] Renamed field 'source_name' to 'source_package_name'.
        - Added a check for hash sums presence. Thanks to
          Goswin von Brederlow <goswin-v-b@web.de>.
        - Added a check for version string presence.
    - Config:
      - Added configuration option 'apt::cache-limit'. Thanks to
        Goswin von Brederlow <goswin-v-b@web.de>. (Closes: #533752)
      - New configuration option 'cupt::update::keep-bad-signatures'.
  * debian/control:
    - Bumped Standards-Version to 3.8.2, no changes needed.
    - Changed Homepage to wiki.debian.org/Cupt.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Sun, 21 Jun 2009 18:42:49 +0300

cupt (0.2.2) unstable; urgency=low

  * Cupt:
    - System:
      - Resolvers/Native:
        - When applying resolve actions, stick packages more aggressively.
      - Worker:
        - 'clean_archives': fixed callback before actual deletion.
        - 'clean_archives': delete only '.deb's.
        - 'clean_archives': fixed error message when deletion failed.
    - Core:
      - Comparing version strings: fixed comparison of versions like 'ab' and
        'ab5'.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Fri, 05 Jun 2009 19:40:19 +0300

cupt (0.2.1) unstable; urgency=low

  * cupt:
    - New 'screenshots' subcommand.
    - New 'clean' subcommand.
    - New 'autoclean' subcommand.
    - Implemented the option '--quiet'.
  * Cupt:
    - System:
      - Worker:
        - New 'clean_archives' method.
        - 'update_release_and_index_data': fixed deleting download progress
          immediately after end of all child processes.
        - 'update_release_and_index_data': don't download Packages/Sources
          when we know they are unchanged by provided hash sums.
      - Resolvers/Native:
        - Fixed dropping solutions by normalized score, not by the original one.
        - Fixed auto-removing of packages which resolver marked to change, but
          in the end they became unneeded anyway.
    - Cache:
      - BinaryVersion:
        - Always set 'source_version_string' field.
    - Config:
      - Added configuration option 'quiet'.
      - New configuration option 'debug::downloader'.
    - Download:
      - Progresses/Console:
        - Don't output progress meter when standard output is not a TTY.
      - Manager:
        - Worker thread: honor 'debug::downloader' configuration option.
        - Worker thread: fixed stucking in some complex conditions.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Tue, 02 Jun 2009 11:34:28 +0300

cupt (0.2.0) unstable; urgency=low

  * cupt:
    - New 'update' subcommand.
  * doc/cupt.1.pod:
    - Mentioned how to set list configuration option.
  * doc/cupt_howto.7.pod:
    - Added.
  * Cupt:
    - System:
      - Resolver*:
        - Merged an infrastructure to allow multiple resolvers to co-exist in
          future.
      - Worker:
        - [API break] 'do_actions' renamed to 'change_system'.
        - New method 'update_release_and_index_data'.
        - Honor 'dpkg::options' option.
    - Download:
      - Manager:
        - Worker thread: handle duplicated download requests that come when
          the original download request is not yet completed. This use case is
          possible 'update' action.
        - Worker thread: handle concurrent request of the same URI properly.
        - Worker thread: pass correct URI to download progress in case of
          ACKed download.
        - 'download' method: switched to modern interface of File::Temp,
          getting rid of compatibility one.
        - 'download' method: use POSIX::mkfifo instead of calling 'mkfifo'
          program.
        - 'download' method: return final download result back to worker
          thread only if this was requested.
        - New forwarding methods 'set_long_alias_for_uri' and
          'set_short_alias_for_uri'.
    - Cache:
      - 'get_pin' method: divided into 'get_original_apt_pin' and 'get_pin'
        methods.
      - New 'get_index_entries' method.
      - New 'get_path_of_release_list' method.
      - New 'get_path_of_index_list' method.
      - New 'get_download_entries_of_index_list' method.
      - New 'get_download_uri_of_release_list' method.
      - Honor 'debug::gpgv' config option to print some debug info while
        verifying signatures.
    - Config:
      - Added configuration option 'dpkg::options'.
      - New configuration option 'debug::gpgv'.
  * debian/control:
    - Recommended 'bzip2' for compressed indexes.
    - Suggested 'lzma' for compressed indexes.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Fri, 29 May 2009 22:29:13 +0300

cupt (0.1.4) unstable; urgency=low

  * cupt:
    - 'policy' subcommand:
      - Fixed old code referrings to 'gettext'.
    - Fixed skipping option-like arguments when searching for a command.
    - Implemented option '--show-reasons' for management actions.
    - New 'copyright' subcommand, similar to 'changelog' subcommand. Currently
      implemented only for installed packages and official Debian and Ubuntu
      repositories.
    - 'changelog', 'copyright' subcommands: work around dropping an epoch from
      version strings in links to Debian/Ubuntu pages.
    - The option '--install-unpacked' went away in favor of new
      '--no-install-unpacked' one, installing unpacked packages is now the
      default.
  * Cupt:
    - System:
      - Resolver:
        - Fixed erroneous autovivification of package entries which are not
          installed when checking for sticks of candidate versions than can
          satisfy forward dependencies.
        - Fixed wrong sharing 'fake satisfied' entries between package entries
          in different solution branches.
        - Honor 'cupt::resolver::track-reasons' configuration option.
      - Worker:
        - APT mangles ':' chars in names of deb archives. Cupt doesn't do the
          same. So, to pick up debs downloaded by libapt, worker now generates
          symlinks from 'right' names to 'mangled' names whenever possible.
        - Moved downloading stage to start of 'do_actions' method.
        - Reverted "Don't introduce action loops when uniting 'remove' and
          'unpack' actions".
        - Instead, tried to drop extraneous action interdepedencies by using and
          checking saved relation info and merging 'unpack' with 'configure'.
        - And, since unconditional merging 'unpack' with 'configure' can
          introduce another dependency loops, perform merge only if the
          operation can "eat" some dependencies.
        - In case some package have only 'configure' action without 'unpack',
          check for conflicts too in a straightforward way.
        - In the series of heterogeneous actions pass '--force-conflicts' to
          the '--unpack' and '--install'.
        - Generate stdin version 2 for the 'dpkg::pre-install-pkgs' hook for
          all hooks declared, not only for apt-listchanges.
        - Implemented the installs, downgrades and removes for the stdin
          version 2 for the 'dpkg::pre-install-pkgs' hook.
    - Config:
      - New configuration option 'cupt::resolver::track-reasons'.
    - Cache:
      - New free subroutine 'get_path_of_debian_copyright'.
      - When parsing release data, require first symbol of version to be digit.
  * doc:
    - cupt.1:
      - Renewed the list of supported APT configuration options.
      - Mentioned the way to send bug reports and IRC discussion channel.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Sun, 24 May 2009 12:02:24 +0300

cupt (0.1.3) unstable; urgency=low

  * debian/control:
    - Fixed misspelled Recommends 'liblocale-gettext-perl'.
    - Allow DM uploads.
  * cupt:
    - 'show' subcommand:
      - Show also source version if present.
    - 'changelog' subcommand:
      - Use source version for fetching remote changelogs if present. Fixes
        determining remote path for versions that had a binary-only rebuild(s).
    - 'policy' subcommand:
      - When called without arguments, print available Releases.
    - Exclude superfluous 'use Locale::gettext', Cupt::Core module do all
      needed manipulations to provide gettext. Thanks to
      David Broome <dbroome@gmail.com>. (Closes: #529167)
  * Cupt:
    - Cache:
      - New method 'get_binary_release_data'.
      - New method 'get_source_release_data'.
      - Include base URI in release info.
      - Installed versions of packages now have archive 'installed',
        codename 'now', vendor 'dpkg' in release info.
      - BinaryVersion:
        - New field 'source_package_version'. It's got filled when the source
          version for package differs from the binary one.
      - Pkg:
        - [API break] Renamed to 'Package'.
        - [API break] Renamed method 'versions' to 'get_versions'.
      - Skip 'Explanation: ' lines when parsing preferences. Thanks to
        Stefano Zacchiroli <zack@debian.org>.
    - Download:
      - Manager, Methods/*:
        - Changed "success" error message from '0' to ''.
      - Manager:
        - Worker thread and 'download' method: now worker thread returns info
          had the download been processed before or not, and 'download' won't
          run post-action for already processed downloads; this change should
          avoid future race conditions when the multiple downloads of the same
          file with enabled postprocessing were scheduled.
        - Worker thread and 'download' method: delay sending result to
          download progress before 'download' acked the result
          (i.e. run post-check for it).
      - Method:
        - New free subroutine 'get_acquire_suboption_for_uri' which honors
          per-host settings.
    - Config:
      - Per-host suboption of 'acquire::*::timeout' is now supported.
    - System:
      - Worker:
        - 'do_actions': perform dpkg lock (if needed) before all other
          prepare actions, not before modifying system.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Mon, 18 May 2009 00:28:09 +0300

cupt (0.1.2) experimental; urgency=low

  * cupt:
    - 'markauto'/'unmarkauto' subcommands:
      - Don't require worker at compilation stage. Speeds up compilation a bit.
    - Implemented '--no-remove' option for management actions.
    - Implemented '--no-auto-remove' option for management actions.
    - Selecting a version for binary package:
      - Allow '-' symbols in distribution names.
    - Properly output error when no command specified.
    - Use '#/usr/bin/env perl' for portability. Thanks to
      Michael Stapelberg <michael@stapelberg.de>.
    - New 'changelog' subcommand. Currently implemented only for installed
      packages and official Debian and Ubuntu repositories.
  * Cupt:
    - Core:
      - 'mydie', 'myerr', 'mywarn' subroutines now print to STDERR. Thanks to
        Stefano Zacchiroli <zack@debian.org>.
      - New subroutine 'is_version_string_native'.
    - Download:
      - Manager:
        - [API break] 'download' method: now one should specify array of URIs,
          not single URI for each download entry. Enables mirroring feature.
        - Advanced error message in download size check.
      - Methods/Curl:
        - Detect HTTP/FTP/HTTPS error codes.
        - Put HTTP/FTP/HTTPS response codes into error messages.
        - Don't put Curl internal error codes into error messages.
        - Follow HTTP redirects if the option
          'acquire::http::allow-redirects' is set to true.
      - Progress:
        - 'get_overall_download_percent': fixed division by zero when
          estimated total is zero.
      - Progresses/Console:
        - Enable auto-flushing when printing to the terminal.
    - System:
      - Worker:
        - Adapted to to changes in 'download' method of download manager.
        - Send also base URI to download progress so it can display it.
        - Give back transparent versioned 'remove','unpack','configure'
          actions and versionful check. Heavy hacks didn't guarantee full
          correctness, no reason to have them anymore.
        - Don't introduce action loops when uniting 'remove' and 'unpack'
          actions. This has to fix upgrading of packages containing
          'Pre-Depends' dependencies finally.
        - Put also installed and downgraded packages to package list version 1
          output for hooks. Dpkg-preconfigure should now work fully under Cupt.
        - Honor 'dpkg::pre-invoke' option.
        - Advanced error output for dpkg 'pre' actions.
        - Honor 'dpkg::post-invoke' option.
      - Resolver:
        - Use 'cupt::resolver::no-remove' option instead of 'no-remove' internal
          param.
        - Use 'cupt::resolver::type' option instead of 'resolver-type' internal
          param.
        - Check 'cupt::resolver::type' option for validity.
        - Use 'cupt::resolver::max-solution-count' option instead of
          'max-solution-cont' internal param.
        - [API break] Removed 'set_params' method, it is not needed anymore.
    - Cache:
      - Typo fix: 'incorrent' -> 'incorrect'. Thanks to
        Stefano Zacchiroli <zack@debian.org>.
      - Implemented 'easy' type of sources.list entry. Thanks to
        Stefano Zacchiroli <zack@debian.org>.
      - Don't choke on empty-for-us index files. Thanks to
        Stefano Zacchiroli <zack@debian.org>.
      - Fixed determining path for storing list file for indexes whose protocol
        doesn't have '//', e.g. 'file'.
        Thanks to Michael Stapelberg <michael@stapelberg.de>.
      - Warn, don't error, when description is not present in Release file.
      - New free subroutine 'get_path_of_debian_changelog'.
      - BinaryVersion:
        - [API break] Advanced return value for 'uris' method.
        - 'uris' method: filter duplicates.
    - Config:
      - New configuration option 'cupt::resolver::no-remove'.
      - New configuration option 'cupt::resolver::type'.
      - New configuration option 'cupt::resolver::max-solution-count'.
      - Changed default value for option
        'cupt::downloader::max-simultaneous-downloads' from 3 to 2.
      - Warn, don't error, on setting unknown list option, just like for
        regular options. Thanks to Stefano Zacchiroli <zack@debian.org>.
      - Skip broken parts of config files and warn, don't immediately stop.
      - Added the configuration option 'dpkg::pre-invoke'.
      - Added the configuration option 'dpkg::post-invoke'.
      - Added the configuration options 'rpm::pre-invoke' and
        'rpm::post-invoke'.
      - New configuration option 'acquire::http::allow-redirects'.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Sun, 10 May 2009 13:23:25 +0300

cupt (0.1.1.1) experimental; urgency=low

  * debian/control:
    - Put libwww-curl-perl to Build-Depends-Indep so t/file_method.t can load
      it.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Fri, 01 May 2009 01:49:41 +0300

cupt (0.1.1) experimental; urgency=low

  * doc/cupt.1.pod:
    - Added 'Author' section.
  * cupt:
    - Action preview prompt:
      - Generate additional warning when deleting essential packages.
      - Require typing the confirmation phrase for really dangerous actions.
      - Changed 'installed' -> 'INSTALLED' for untrusted packages warning.
    - 'satisfy' subcommand:
      - Now accepts sequences of relation expressions divided by commas within
        one argument.
    - 'config-dump' subcommand:
      - Added a mode to print a value of only one configuration option.
    - 'show' subcommand:
      - Changed 'PreDepends' -> 'Pre-Depends' in output.
    - Implemented option '--installed-only' for some query actions.
    - Implemented option '--download-only' for management actions.
  * Cupt:
    - Core:
      - 'human_readable_size_string': don't print fractional part for small
        float values.
    - Download:
      - Method, Methods/*:
        - [API break] 'sub_callback' in 'perform', added fetched bytes
          parameter for 'downloading' callback
        - Various documentation improvements.
      - Manager:
        - Road all progress requests through own pipe, not directly.
        - Update progress meter several times during a second.
        - Made more strings translatable.
      - Progress:
        - New method 'get_start_time'.
        - New method 'get_long_alias_for_uri'.
        - New method 'get_short_alias_for_uri'.
        - [API break] The control and flow logic was moved from
          Progresses/Console to 'progress' method.
        - New method 'hook' for subclasses.
        - New method 'get_overall_download_progress'.
        - New accessor/mutator 'download_entries'.
        - New method 'get_download_speed'.
        - New class-wide parameter variable 'o_download_speed_accuracy';
        - Various documentation improvements.
      - Progresses/Console:
        - Substituted obsoleted 'progress' method with new 'hook' method.
        - Fixed dangling, wrong-placed console cursor.
        - Also output download speed.
        - Output count of downloaded bytes for each package in
          human-readable form too (in addition to all size bytes count for
          package). In four words, "10829837/15.9MiB" -> '10.1MiB/15.9MiB'.
    - System:
      - Worker:
        - Honor 'cupt::worker::download-only' option.
        - Added 'debug::worker' config option to print some debug info.
        - Bump Pre-Depends requirements to 'configure' to make sure to not
          violate Debian Policy.
        - Merge all 'unpack' + 'configure' actions into 'install' action
          unconditionally.
        - Don't create fake 'remove' actions, just use existing 'install'
          ones instead. This should resolve problems with scheduling
          upgrading packages containing 'Pre-Depends'.
        - Made all inter-action relations unversioned, this should ensure that
          all 'install' -> 'remove' and 'remove' -> 'install' dependencies are
          not underestimated.
        - Ensure that download manager is destroyed before processing the
          result of downloads.
    - Config:
      - New option 'cupt::worker::download-only', defaults to false.
      - Use value of 'dir::bin::dpkg', not plain 'dpkg' to obtain
        archirecture.
      - The option 'gpgv::trustedkeyring' now defaults to
        '/var/lib/cupt/trusted.gpg'.
    - Cache:
      - Introduce the hack to copy APT's trusted keyring whenever possible to
        cupt's keyring place. It will be removed once key update mechanism
        would be implemented.
      - When checking signatures, generate proper error message if the keyring
        file doesn't exist.
      - Relation:
        - New free subroutine 'parse_relation_line' for parsing relation
          sequences.
  * debian/libcupt-perl.postinst:
    - Don't mess with /etc/apt/trusted.gpg for now. Instead copy it to cupt's
      own keyring place.
  * debian/libcupt-perl.prerm:
    - Introduced to clean up /var/lib/cupt directory.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Thu, 30 Apr 2009 23:19:35 +0300

cupt (0.1.0) experimental; urgency=low

  * Initial release. Dedicated to Pavel Chernyshov. Developers and advanced
    users only.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Tue, 07 Apr 2009 23:23:04 +0300
